Package: MOMA
Title: Multi Omic Master Regulator Analysis
Version: 1.25.0
Authors@R: c(person("Evan","Paull",email="evanpaull@gmail.com", role=c("aut")), 
              person("Sunny", "Jones", email = "sunnyjjones@gmail.com", 
              role = c("aut", "cre")), person("Mariano", "Alvarez", 
              email = "reef103@gmail.com", role = c("aut")))
Description: This package implements the inference of candidate master regulator
  proteins from multi-omics' data (MOMA) algorithm, 
  as well as ancillary analysis and visualization functions. 
Depends: R (>= 4.0)
License: GPL-3
Encoding: UTF-8
LazyData: true
BugReports: https://github.com/califano-lab/MOMA/issues
RoxygenNote: 7.1.0
biocViews: Software, NetworkEnrichment, NetworkInference, Network,
        FeatureExtraction, Clustering, FunctionalGenomics,
        Transcriptomics, SystemsBiology
Imports: circlize, cluster, ComplexHeatmap, dplyr, ggplot2, graphics,
        grid, grDevices, magrittr, methods, MKmisc,
        MultiAssayExperiment, parallel, qvalue, RColorBrewer, readr,
        reshape2, rlang, stats, stringr, tibble, tidyr, utils
Suggests: BiocStyle, knitr, rmarkdown, testthat, viper
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/MOMA
git_branch: devel
git_last_commit: e936c02
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-05-07
NeedsCompilation: no
Packaged: 2026-05-07 22:58:03 UTC; biocbuild
Author: Evan Paull [aut],
  Sunny Jones [aut, cre],
  Mariano Alvarez [aut]
Maintainer: Sunny Jones <sunnyjjones@gmail.com>

# MOMA

This package is used for running Multi-Omic Master Regulator Analysis (MOMA).
See vignette for full steps to running the analysis.

bioRXiv version of paper can be found here: https://www.biorxiv.org/content/10.1101/758268v1

#' Cluster Range
#' 
#' This function generate an cluster structure with 'k' groups and computes the cluster reliability score
#' where 'k' is a range of values 
#' 
#' @param dis Distance object
#' @param range vector with start and end 'k' 
#' @param step Integer indicating the incremental number of clusters to add in each iteration
#' @param cores Maximum number of CPU cores to use
#' @param method Either 'pam' k-mediods or kmeans. Must supply the original data matrix if using kmeans
#' @param data Original data matrix
#' @return list of cluster reliability scores by 'k', 'clustering' (the vector solution) and 'reliability' 
#' as well as 'medoids' labels
#' @keywords internal
clusterRange <- function(dis, range = c(2, 100), step = 1, cores = 1, method = c("pam", "kmeans"), data = NULL) {
  
  
  #idx <- 1
  result <- parallel::mclapply(range[1]:range[2], function(k, dis) {
    
    solution <- NULL
    clustering <- NULL
    centers <- NULL
    silinfo <- NULL
    if (method == "pam") {
      solution <- cluster::pam(dis, k, diss = TRUE, cluster.only = FALSE)
      clustering <- solution$clustering
      centers <- solution$medoids
      silinfo <- solution$silinfo
    } else if (method == "kmeans") {
      data[which(is.na(data))] <- 0
      solution <- stats::kmeans(data, k)
      clustering <- solution$cluster
      centers <- solution$centers
    } else {
      stop("Unrecognized clustering method")
    }
    
    cr <- clusterReliability(clustering, 1/as.matrix(dis), method = "global")
    element.cr <- clusterReliability(clustering, 1/as.matrix(dis), method = "element")
    cluster.cr <- clusterReliability(clustering, 1/as.matrix(dis), method = "cluster")
    
    
    ret <- NULL
    list(centers = centers, clustering = clustering, k = k, silinfo = silinfo,
         reliability = as.numeric(cr), element.reliability = element.cr, 
         cluster.reliability = cluster.cr)
    
  }, dis = dis, mc.cores = cores)
  
  result <- setNames(result, paste0(seq(range[1], range[2]), "clusters"))
  
  # create fields that have all the cluster reliability scores and all the avg silhouette scores
  rel.scores <- vapply(result, function(x){ x[["reliability"]] }, FUN.VALUE = double(1))
  sil.scores <- vapply(result, function(x){ x[["silinfo"]][["avg.width"]] }, FUN.VALUE = double(1))
  
  result[["all.cluster.reliability"]] <- rel.scores
  result[["all.sil.avgs"]] <- sil.scores
  
  result
}

#' Cluster membership reliability estimated by enrichment analysis
#'
#' This function estimates the cluster membership reliability using aREA
#'
#' @param cluster Vector of cluster memberships or list of cluster memberships
#' @param similarity Similarity matrix
#' @param xlim Optional vector of 2 components indicating the limits for computing AUC
#' @param method Character string indicating the mthod to compute reliability, 
#' either by element, by cluster or global
#' @return Reliability score for each element
#' @keywords internal
clusterReliability <- function(cluster, similarity, xlim = NULL, 
                               method = c("element", "cluster", "global")) {
  method <- match.arg(method)
  if (!is.list(cluster)) 
    cluster <- list(cluster = cluster)
  switch(method, element = {
    res <- lapply(cluster, function(cluster, similarity) {
      reg <- split(names(cluster), cluster)
      tmp <- sREA(similarity, reg)
      tmp <- lapply(seq_len(nrow(tmp)), function(i, tmp, reg) {
        tmp[i, ][colnames(tmp) %in% reg[[which(names(reg) == (rownames(tmp)[i]))]]]
      }, tmp = tmp, reg = reg)
      res <- unlist(tmp, use.names = FALSE)
      names(res) <- unlist(lapply(tmp, names), use.names = FALSE)
      return(res[match(names(cluster), names(res))])
    }, similarity = similarity)
    if (length(res) == 1) return(res[[1]])
    return(res)
  }, cluster = {
    rel <- clusterReliability(cluster, similarity, method = "element")
    if (!is.list(rel)) rel <- list(cluster = rel)
    if (is.null(xlim)) xlim <- range(unlist(rel, use.names = FALSE))
    res <- lapply(seq_len(length(cluster)), function(i, cluster, rel, xlim) {
      tapply(rel[[i]], cluster[[i]], function(x, xlim) {
        1 - integrateFunction(ecdf(x), xlim[1], xlim[2], steps = 1000)/diff(xlim)
      }, xlim = xlim)
    }, cluster = cluster, rel = rel, xlim = xlim)
    if (length(res) == 1) return(res[[1]])
    return(res)
  }, global = {
    rel <- clusterReliability(cluster, similarity, method = "element")
    if (!is.list(rel)) rel <- list(cluster = rel)
    if (is.null(xlim)) xlim <- range(unlist(rel, use.names = FALSE))
    res <- lapply(rel, function(x, xlim) {
      1 - integrateFunction(ecdf(x), xlim[1], xlim[2], steps = 1000)/diff(xlim)
    }, xlim = xlim)
    if (length(res) == 1) return(res[[1]])
    return(res)
  })
}

#' Simple one-tail rank based enrichment analysis sREA
#' (for cluster analysis)
#' 
#' This function performs simple 1-tail rank based enrichment analysis
#' 
#' @param signatures Numeric matrix of signatures
#' @param groups List containing the groups as vectors of sample names
#' @return Matrix of Normalized Enrichment Zcores
#' @keywords internal
sREA <- function(signatures, groups) {
  if (is.null(nrow(signatures))) 
    signatures <- matrix(signatures, length(signatures), 1, dimnames = list(names(signatures), "sample1"))
  # ranked signatures matrix: samples are rows. Rank
  sig <- qnorm(apply(signatures, 2, rank)/(nrow(signatures) + 1))
  gr <- vapply(groups, function(x, samp) {
    samp %in% x
  }, samp = rownames(sig), FUN.VALUE = logical(length(unlist(groups))))
  gr <- t(gr)
  # non negative counts
  nn <- rowSums(gr)
  # fractions of prev computation rows are groups
  gr <- gr/nn
  es <- gr %*% sig
  return(es * sqrt(nn))
}

#' Numerical integration of functions
#' 
#' Integrates numerically a function over a range using the trapezoid method
#' 
#' @param f Function of 1 variable (first argument)
#' @param xmin Number indicating the min x value
#' @param xmax Number indicating the max x value
#' @param steps Integer indicating the number of steps to evaluate
#' @param ... Additional arguments for \code{f}
#' @return Number
#' @keywords internal
integrateFunction <- function(f, xmin, xmax, steps = 100, ...) {
  x <- seq(xmin, xmax, length = steps)
  y <- f(x, ...)
  integrateTZ(x, y)
}

#' Integration with trapezoid method
#' 
#' This function integrate over a numerical range using the trapezoid method
#' 
#' @param x Numeric vector of x values
#' @param y Numeric vector of y values
#' @return Number
#' @keywords internal
integrateTZ <- function(x, y) {
  pos <- order(x)
  x <- x[pos]
  y <- y[pos]
  idx = 2:length(x)
  return(as.double((x[idx] - x[idx - 1]) %*% (y[idx] + y[idx - 1]))/2)
}

#' Use 'aREA' to calculate the enrichment between each genomic event - 
#' VIPER inferred protein pair. 
#' 
#' Requires pre-computed VIPER scores and a binary events matrix. Will use only 
#' samples in both event and VIPER matrices.
#'  
#' @param vipermat Pre-computed VIPER scores with samples as columns and proteins
#'  as rows 
#' @param events.mat Binary 0/1 events matrix with samples as columns and genes 
#' or events as rows
#' @param whitelist Only compute associations for events in this list
#' @param min.events Only compute enrichment if the number of samples with these
#'  events is GTE to this
#' @param event.type Name of the event type being analyzed
#' @param verbose whether to print extra progress statements
#' @return A matrix of aREA scores, dimensions are nrow(events.mat) x nrow(vipermat) 
#' @keywords internal
associateEvents <- function(vipermat, events.mat, min.events = NA, 
                            whitelist = NA, 
                            event.type = c("Amplifications","Deletions", 
                                            "Mutations","Fusions", NA),
                            verbose) {
    event.type <- match.arg(event.type)
    if (is.null(events.mat)) {
        message("Null ", event.type, " matrix, skipping..")
        return(NULL)
    }
    if (dim(events.mat)[1] == 0 | dim(events.mat)[2] == 0) {
        message("Not enough ", event.type,", skipping")
        return(NULL)
    }
    
    # subset the two matrices to common samples
    common.samples <- intersect(colnames(vipermat), colnames(events.mat))
    vipermat <- vipermat[, common.samples]
    events.mat <- events.mat[, common.samples]
    
    # include only whitelist items
    if (!(is.na(whitelist))) {
        events.mat <- events.mat[intersect(rownames(events.mat), whitelist), ]
    }
    # filter to minmum number of somatic events
    if (!is.na(min.events)) {
        events.mat <- events.mat[apply(events.mat, 1, sum, na.rm = TRUE) >= min.events,]
    }
    # test again after removing low freuquency events
    if (is.null(dim(events.mat))) {
        message("Not enough ", event.type,", skipping")
        return(NULL)
    } else if (dim(events.mat)[1] == 0 | dim(events.mat)[2] == 0) {
        message("Not enough ", event.type,", skipping")
        return(NULL)
    }
    
    nes <- areaEnrich(events.mat, vipermat, event.type, verbose = verbose)
    nes
}


#' aREA.enrich Compute aREA enrichment between all pairwise combinations of 
#' VIPER proteins and gene-level events
#' 
#' @param events.mat A Binary 0/1 matrix with columns as samples, and rows as 
#' proteins
#' @param vipermat A VIPER network of inferred activity scores with columns as 
#' samples, and rows as proteins
#' @param event.type Name of the event type for printing purposes
#' @param verbose whether to print extra progress statements
#' @return A matrix of enrichment scores with rows as event/gene names and 
#' columns as VIPER protein names
#' @keywords internal
areaEnrich <- function(events.mat, vipermat, event.type, verbose) {
    
    # Convert mutations into a regulon-like object
    events.regulon <- apply(events.mat, 1, function(x) {
        l <- names(x[which(x == TRUE)])
        return(l)
    })
    
    # Calculate raw enrichment scores: each mutation against each TF 
    # columns are TFs, rownames are mutations
    es <- rea(t(vipermat), events.regulon, event.type = event.type, verbose = verbose)
    # Analytical correction
    dnull <- reaNULL(events.regulon)
    
    # Calculate pvalue of ES
    pval <- t(vapply(seq_len(length(dnull)), function(i, es, dnull) {
        dnull[[i]](es[i, ])$p.value
    }, es = es$groups, dnull = dnull, FUN.VALUE = numeric(ncol(es$groups))))
    
    # Convert the pvalues into Normalized Enrichment Scores
    nes <- qnorm(pval/2, lower.tail = FALSE) * es$ss
    # print (dim(nes)) print (length(events.regulon))
    rownames(nes) <- names(events.regulon)
    colnames(nes) <- rownames(vipermat)
    dimnames(pval) <- dimnames(nes)
    nes[is.na(nes)] <- 0
    # columns are TFs, rows are genomic events
    nes
}


#' This function calculates an Enrichment Score of Association based on how the
#' features rank on the samples sorted by a specific gene
#' 
#' @importFrom utils setTxtProgressBar txtProgressBar
#' @param eset Numerical matrix
#' @param regulon A list with genomic features as its names and samples as its 
#' entries, indicating presence of event
#' @param minsize The minimum number of events to use when calculating enrichment
#' @param maxsize The maximum number of events to use when calculating enrichment 
#' @param event.type Type of event being analyzed
#' @param verbose whether to print extra progress statements
#' @return A list containing two elements:
#' \describe{
#' \item{groups}{Regulon-specific NULL model containing the enrichment scores}
#' \item{ss}{Direction of the regulon-specific NULL model}
#' }
#' @keywords internal
rea <- function(eset, regulon, minsize = 1, maxsize = Inf, event.type = NA, verbose) {
    # Filter for minimum sizes
    sizes <- vapply(regulon, length, FUN.VALUE = numeric(1))
    regulon <- regulon[sizes >= minsize]
    sizes <- vapply(regulon, length, FUN.VALUE = numeric(1))
    regulon <- regulon[sizes <= maxsize]
    
    temp <- unique(unlist(regulon))
    tw <- rep(1, length(temp))
    names(tw) <- temp
    
    # Calculations
    t <- eset
    t2 <- apply(t, 2, rank)/(nrow(t) + 1) * 2 - 1
    t1 <- abs(t2) * 2 - 1
    t1[t1 == (-1)] <- 1 - (1/length(t1))
    
    
    # tnorm
    t1 <- qnorm(t1/2 + 0.5)
    t2 <- qnorm(t2/2 + 0.5)
    
    if(is.na(event.type)) {
        event.type = "genomic events"
    }
    
    # Print some progress bar
    if(verbose) {
        message("\nComputing associations of ", length(regulon)," ", 
                event.type," with ", ncol(eset), " regulators")
        message("Process started at ", date())
        pb <- txtProgressBar(max = length(regulon), style = 3) 
    }
    
    temp <- lapply(seq_len(length(regulon)), function(i,regulon,t1,t2,tw,pb) {
        hitsamples <- regulon[[i]]
        hitsamples <- intersect(hitsamples, rownames(t1))
        
        # Mumbo-jumbo
        pos <- match(hitsamples, rownames(t1))
        
        heretw <- tw[match(hitsamples, names(tw))]
        
        sum1 <- matrix(heretw, 1, length(hitsamples)) %*% t2[pos, ]
        ss <- sign(sum1)
        ss[ss == 0] <- 1
        if(verbose) { setTxtProgressBar(pb, i) }
        sum2 <- matrix(0 * heretw, 1, length(hitsamples)) %*% t1[pos, ]
        return(list(es = as.vector(abs(sum1) + sum2 * (sum2 > 0))/sum(heretw), 
                    ss = ss))
    }, regulon = regulon, pb = pb, t1 = t1, t2 = t2, tw = tw)
    names(temp) <- names(regulon)
    
    if(verbose) { message("\nProcess ended at ", date()) }
    es <- t(vapply(temp, function(x) x$es,
                   FUN.VALUE = numeric(length(temp[[1]][[1]]))))
    ss <- t(vapply(temp, function(x) x$ss, 
                   FUN.VALUE = numeric(length(temp[[1]][[1]]))))
    colnames(es) <- colnames(ss) <- colnames(eset)
    return(list(groups = es, ss = ss))
}


#' This function generates the NULL model function, which computes the 
#' normalized enrichment score and associated p-value
#' 
#' @param regulon A list with genomic features as its names and samples as its 
#' entries
#' @param minsize Minimum number of event (or size of regulon)  
#' @param maxsize Maximum number of event (or size of regulon)  
#' @return A list of functions to compute NES and p-value
#' @keywords internal
reaNULL <- function(regulon, minsize = 1, maxsize = Inf) {
    # Filter for minimum sizes
    sizes <- vapply(regulon, length, FUN.VALUE = numeric(1))
    regulon <- regulon[sizes >= minsize]
    sizes <- vapply(regulon, length, FUN.VALUE = numeric(1))
    regulon <- regulon[sizes <= maxsize]
    # complete list of all genes in any regulon
    temp <- unique(unlist(regulon))
    # list of all genes, weighted by 1
    tw <- rep(1, length(temp))
    names(tw) <- temp
    lapply(regulon, function(x, tw) {
        ww <- tw[match(x, names(tw))]
        ww <- ww/max(ww)
        # now it's a constant?
        ww <- sqrt(sum(ww^2))
        return(function(x, alternative = "two.sided") {
            x <- x * ww
            p <- switch(pmatch(alternative, c("two.sided", "less", "greater")), 
                        pnorm(abs(x), lower.tail = FALSE) * 2, 
                        pnorm(x, lower.tail = TRUE), pnorm(x,lower.tail = FALSE))
            list(nes = x, p.value = p)
        })
    }, tw = tw)
}

#' Use Stouffer's method to combine z-scores of DIGGIT interactions for each cMR protein.
#' 
#' This function combines only positively associated DIGGIT scores by default to create a culmulative DIGGIT score for each cMR.
#' 
#' @import stats
#' @param interactions A list indexed by TF, includes z-scores or p-values for each interacting event
#' @param from.p Integrate p-values or z-scores (default z-scores; from.p = FALSE)
#' @param pos.nes.only Use only positive NES scores to rank proteins (default TRUE)
#' @return A list indexed by TF, a stouffer integrated z-score
stoufferIntegrateDiggit <- function(interactions, from.p = FALSE, pos.nes.only = TRUE) {
  
  ## Integrate p-values for each TF
  diggit.integrated.z <- unlist(lapply(interactions, function(scores) {
    # stouffer's method
    if (from.p) {
      scores <- -qnorm(scores)
    }
    
    if (length(scores) == 1) {
      if (pos.nes.only) {
        if (as.numeric(scores) > 0) {
          return(as.numeric(scores))
        } else {
          return(0)
        }
      }
    }
    
    integrated.z <- 0
    if (pos.nes.only) {
      scores <- scores[which(as.numeric(scores) > 0)]
      integrated.z <- sum(scores)/sqrt(length(scores))
      if (is.nan(integrated.z)) {
        integrated.z <- 0
      }
    } else {
      integrated.z <- sum(abs(scores))/sqrt(length(scores))
    }
    integrated.z
  }))
  names(diggit.integrated.z) <- names(interactions)
  diggit.integrated.z
}


#' @title dispatch method for either CNV location corrected or SNV
#' @param interactions List of MR - Genomic Event interactions, inferred by DIGGIT
#' @param cytoband.map Data.frame mapping Entrez.IDs to cytoband locations
#' @return Z-scores for each MR
stoufferIntegrate <- function(interactions, cytoband.map = NULL) {
  z <- NULL
  if (!is.null(cytoband.map)) {
    # need to create a vector with gene
    map.vec <- cytoband.map$Cytoband
    names(map.vec) <- cytoband.map$Entrez.IDs
    z <- cnvScoreStouffer(map.vec, interactions)
  } else {
    z <- stoufferIntegrateDiggit(interactions)
  }
  z
}


#' Integrate CNV scores 
#' 
#' @param mapping a named vector of genomic locations/cytoband IDs. 
#' names are the gene names for each--i.e. a many to one mapping from HUGO or entrez IDs to cytoband location
#' @param diggit.interactions list indexed by MR/TF name in Entrez Space each points to a named vector of NES / z-scores associated with entrez IDs for each interacting event. 
#' @param cytoband Boolean to use cytoband locations for computing final integrated score
#' @param from.p Boolean, set TRUE if diggit.interaction values are p-values instead of z-scores
#' @param pos.nes.only Boolean, only consider positive DIGGIT association scores when ranking candidate MRs (default=TRUE)
#' @return A vector of z-scores, named by the Master Regulators in 'diggit.interactions' 
cnvScoreStouffer <- function(mapping, diggit.interactions, cytoband = TRUE, from.p = FALSE, pos.nes.only = TRUE) {
  
  mapped.diggit <- mapScoresCnvBand(mapping, diggit.interactions, from.p = FALSE, pos.nes.only = TRUE)
  
  # apply over each TF/MR: sum the named vector of scores
  integrated.z.scores <- unlist(lapply(mapped.diggit, function(scores) {
    
    # now integrate scores with Stouffer's method
    integrated.z <- sum(scores)/sqrt(length(scores))
    if (is.null(integrated.z)) {
      integrated.z <- 0
    }
    if (is.nan(integrated.z)) {
      integrated.z <- 0
    }
    integrated.z
  }))
  
  names(integrated.z.scores) <- names(diggit.interactions)
  integrated.z.scores
}

#' Map scores to cytoband location 
#' 
#' @param mapping a named vector of genomic locations/cytoband IDs. 
#' names are the gene names for each--i.e. a many to one mapping from HUGO or entrez IDs to
#' cytoband location
#' @param diggit.interactions list indexed by MR/TF name in Entrez Space
#' @param from.p DIGGIT interactions are in p-value format instead of z-score (default=FALSE)
#' @param pos.nes.only Only consider positive associations with NES scores (default=TRUE)
#' each points to a named vector of NES / z-scores associated with entrez IDs for each interacting event.
#' @return A list of input scores, now named by cytoband location
mapScoresCnvBand <- function(mapping, diggit.interactions, from.p = FALSE, pos.nes.only = TRUE) {
  
  # apply over each TF/MR:
  mapped.scores <- lapply(diggit.interactions, function(x) {
    
    # print (paste('Integrating: ', length(x), ' interactions ')) check for zero interactions case
    if (length(x) == 0) {
      return(0)
    }
    
    scores <- NULL
    # corner case of 1 interaction only...
    if (length(x) == 1) {
      score <- 0
      if (from.p) {
        score <- qnorm(min(x), lower.tail = FALSE)
      } else {
        if (pos.nes.only) {
          # Only include positive scores
          score <- x
          if (score < 0) {
            score <- 0
          }
        } else {
          # Only include positive scores
          score <- x
        }
      }
      names(score) <- names(x)
      scores <- score
    } else {
      
      # gather either cytoband locations or Locus names are the genes in ENTREZ space
      
      locations <- na.omit(mapping[as.character(names(x))])
      
      if (length(locations) == 0) {
        message("Didn't find any genomic locations for ", names(x))
        return(0)
      }
      
      # find the highest MR-gene score in this location and use that as a summary
      scores <- unlist(lapply(unique(locations), function(loc) {
        # for each location, get entrez gene IDs
        genes.this.loc <- as.character(names(locations[which(locations == loc)]))
        # determine if we're using z-scores or p-values here
        scores.thisLoc <- x[genes.this.loc]
        if (length(scores.thisLoc) == 0) {
          return(NA)
        }
        score <- NULL
        if (from.p) {
          score <- qnorm(min(scores.thisLoc), lower.tail = FALSE)
        } else {
          if (pos.nes.only) {
            # Only include positive scores
            score <- as.numeric(max(scores.thisLoc))
            if (score < 0) {
              score <- 0
            }
          } else {
            # take the max abs value of the score
            score <- scores.thisLoc[which.max(abs(scores.thisLoc))]
          }
        }
        score
      }))
      names(scores) <- unique(locations)
    }
    
    # add fusion events if necessary
    scores
  })
  names(mapped.scores) <- names(diggit.interactions)
  mapped.scores
}


#' @title Combine DIGGIT inferences with pathway knowledge 
#' @param diggit.int List of interactions between MRs - Genomic events, inferred
#'  by DIGGIT
#' @param pathway - a list indexed by TF/MR entrez ID, contains the named vector
#'  of p-values for interactions 
#' @param pos.nes.only Only use positive associations between MR activity and 
#' presence of events (default = True)
#' @param cores Number of cores to use if parallel is selected
#' @return numeric vector, zscores for each TF/MR
#' @keywords internal
pathwayDiggitIntersect <- function(diggit.int, pathway, 
                                   pos.nes.only = TRUE, cores = 1) {
  
  
  pathway.pvals <- parallel::mclapply(names(diggit.int), function(tf) {
    
    partners.pvals <- pathway[[as.character(tf)]]
    
    # 
    if (pos.nes.only) {
      I <- diggit.int[[as.character(tf)]]
      I <- I[which(I > 0)]
      tf.diggit.interactors <- unique(names(I))
    } else {
      tf.diggit.interactors <- unique(names(diggit.int[[as.character(tf)]]))
    }
    
    # Find partners PrePPI P-values
    pvals <- partners.pvals[which(names(partners.pvals) %in% tf.diggit.interactors)]
    
    if (length(pvals) == 0) {
      return(1)
    }
    if (length(pvals) == 1) {
      return(as.numeric(pvals))
    }
    pvals
  }, mc.cores = cores)
  names(pathway.pvals) <- names(diggit.int)
  
  ## Compute both Stouffer integrated z-scores and Fisher integrated p-values
  integrated.z <- unlist(lapply(pathway.pvals, function(x) {
    
    x[which(x == 1)] <- 0.5
    iz <- sum(abs(qnorm(x)))/sqrt(length(x))
    iz
  }))
  names(integrated.z) <- names(pathway.pvals)
  
  integrated.p <- unlist(lapply(pathway.pvals, function(x) {
    
    if (length(x) == 1) {
      return(x)
    }
    
    integrated.p <- -pchisq(-2 * sum(log(x)), 2 * length(x), log.p = TRUE)
    integrated.p
  }))
  names(integrated.p) <- names(diggit.int)
  
  # return the z-scores only
  integrated.z
  
}


#' Implements the conditional Bayes model to combine VIPER scores with diggit 
#' and pathway scores
#'
#' @param viper.scores numeric Vector 
#' @param pathway.scores List , double indexed by each pathway dataset, 
#' then with type char. Each points to a numeric score vectors in [0,R+] for each
#' @param diggit.scores List indexed by type char, with numeric score vectors in [0,R+] for each
#' @return a named vector of empirical p-values for each protein/candidate Master Regulator
#' @keywords internal
conditionalModel <- function(viper.scores, diggit.scores, pathway.scores) {
  
  integrated.pvals <- unlist(lapply(names(viper.scores), function(VIP) {
    # VIP = Viper Inferred Protein
    
    # VIPER scores are the independent model component
    viper.p <- empiricalP(VIP, viper.scores)
    
    # for each type, produce p-values for DIGGIT as well as each dependent 
    # pathway or pathway based algorithm (including CINDy)
    all.pvals <- c(viper.p)
    for (type in names(diggit.scores)) {
      
      # DIGGIT is conditioned on VIPER scores
      diggit.p <- conditionalP(VIP, viper.scores, diggit.scores[[type]])
      # Pathway scores are conditioned on DIGGIT
      pathway.pvals <- c()
      for (pathway in names(pathway.scores)) {
        if (length(pathway.scores[[pathway]]) == 0) {
          next
        } else if (!(type %in% names(pathway.scores[[pathway]]))) {
          stop(paste("Can't find entry for ", type, " in pathway ranks ", pathway))
        }
        pathway.p <- conditionalP(VIP, diggit.scores[[type]], pathway.scores[[pathway]][[type]])
        pathway.pvals <- c(pathway.p, pathway.pvals)
      }
      all.pvals <- unlist(c(all.pvals, diggit.p, pathway.pvals))
    }
    
    x <- na.omit(all.pvals)
    # Fisher's method
    integrated.p <- 1 - pchisq(-2 * sum(log(x)), 2 * length(x), log.p = FALSE)
    integrated.p
  }))
  names(integrated.pvals) <- names(viper.scores)
  integrated.pvals
}


#' Get the empirical p-value from a distribution (vector)
#' 
#' @param gene.name Character
#' @param x named Vector of scores for the distribution
#' @return a numeric p-value between 0 and 1
#' @keywords internal
empiricalP <- function(gene.name, x) {
  
  # unranked genes in either distribution should get no score from this
  if (!(as.character(gene.name) %in% names(x))) {
    return(1)
  }
  
  n.gte <- length(which(rank(x) >= rank(x)[as.character(gene.name)]))
  p.one.tail <- n.gte/(length(x) + 1)
  p.one.tail
}


#' Get the conditional p-value of a gene
#'  
#' @param gene.name Character
#' @param condition.on named Vector of scores for the distribution we are conditioning ON
#' @param x named Vector of scores for the dependent distribution
#' @return a numeric p-value between 0 and 1
#' @keywords internal
conditionalP <- function(gene.name, condition.on, x) {
  
  # null ranks for all: return NA
  if (all(x == 0)) {
    return(NA)
  }
  
  # unranked genes in either distribution should get no score from this
  if (!(as.character(gene.name) %in% names(condition.on))) {
    return(1)
  }
  if (!(as.character(gene.name) %in% names(x))) {
    return(1)
  }
  
  # these names are GTE the gene of interest
  gte <- names(which(rank(condition.on) >= 
                       rank(condition.on)[as.character(gene.name)]))
  
  conditional.dist <- x[gte]
  
  n.gte <- length(which(rank(conditional.dist) >= 
                          rank(conditional.dist)[as.character(gene.name)]))
  # empirical p-value: note the GTE means we count the value itself
  p.one.tail <- n.gte/(length(conditional.dist) + 1)
  p.one.tail
  
}

#' Function to normalize TF scores
#' 
#' @param vipermat - matrix of VIPER scores with columns as samples, 
#' rows as protein names
#' @param fdr.thresh - BH-FDR threshold (default 0.05 FDR rate)
#' @return A vector of normalized z-scores, named by TF id
#' @keywords internal
viperGetTFScores <- function(vipermat, fdr.thresh = 0.05) {
  
  # for each gene, count the number samples with scores for each, and weight by that
  w.counts <- apply(vipermat, 1, function(x) {
    data.counts <- length(which(!is.na(x)))
    data.counts
  })
  w.counts <- w.counts/ncol(vipermat)
  
  vipermat[is.na(vipermat)] <- 0
  
  # normalize element scores to sum to 1 (optional - use weighted element scores based on silhouette)
  element.scores <- rep(1, ncol(vipermat))
  element.scores <- element.scores/sum(element.scores)
  
  # mean weighted VIPER score across samples
  w.means <- apply(vipermat, 1, function(x) {
    res <- sum(x * element.scores)
    res
  })
  # weight by the counts for each
  w.means <- w.means * w.counts
  names(w.means) <- rownames(vipermat)
  
  # only look at those with positive (high) score w.means <- sort(w.means[which(w.means > 0)], decreasing=TRUE)
  
  zscores <- w.means
  zscores
}


#' Calculate p-values from pseudo zscores / VIPER aREA scores, threshold
#' 
#' @param zscores Vector of normally distributed z-scores representing protein 
#' activities. 
#' @param fdr.thresh Threshold for false discovery rate, default is 0.05
#' @return Get the names of proteins with significant z-scores, after 
#' multi-hypothesis correction
#' @keywords internal
viperGetSigTFS <- function(zscores, fdr.thresh = 0.05) {
  
  # calculate pseudo-pvalues and look at just significant pvals/scores
  pvals <- -pnorm(abs(zscores), log.p = TRUE) * 2
  pvals[which(pvals > 1)] <- 1
  # correct unless option is NULL
  sig.idx <- which(p.adjust(pvals, method = "BH") < fdr.thresh)
  pvals <- pvals[sig.idx]
  
  names(pvals)
}


#' Compute the empirical q-values of each genomic-event/VIPER gene pair 
#' 
#' Use against the background distribution of associations with a given set of 
#' 'null' VIPER genes (i.e. low activity TFs) 
#' 
#' @param vipermat viper inferences matrix, samples are columns, 
#' rows are TF entrez gene IDs 
#' @param nes scores for each mutation (rows) against each TF (columns) 
#' @param null.TFs low-importance TFs used to calculate null distributions
#' @param alternative Alternative defaults to 'both' : significant p-values can 
#' come from both sides of the null distribution 
#' @return A named list of qvalues for each TF/cMR protein. Each entry contains 
#' a vector of q-values for all associated events; names are gene ids 
#' @keywords internal
getDiggitEmpiricalQvalues <- function(vipermat, nes, null.TFs, 
                                      alternative = "both") {
  
  # subset NES to Viper Proteins in the vipermat only
  nes <- nes[, as.character(rownames(vipermat))]
  
  nes.em.qvals <- apply(nes, 1, function(x, alternative) {
    
    null.VEC <- x[as.character(null.TFs)]
    null.VEC <- null.VEC[which(!is.na(null.VEC))]
    # get empirical q-values for both upper and lower tails of NES / DIGGIT statistics
    qvals <- getEmpiricalQvals(x, null.VEC, alternative)
    qvals
  }, alternative = alternative)
  
  names(nes.em.qvals) <- rownames(nes)
  nes.em.qvals
}


#' Get empirical qvals
#' 
#' @param test.statistics P-values generated from the test comparisons
#' @param null.statistics P-values generated under the null (permutation) model
#' @param alternative Optional : 1 or 2 tails used to generate the p-value
#' @return A list with both the qvalues and empirical p-values from the supplied
#' test and null stats
#' @keywords internal
getEmpiricalQvals <- function(test.statistics, null.statistics, 
                              alternative = "both") {
  
  # calculate the upper and lower tail
  if (alternative == "both") {
    
    test.statistics <- sort(abs(test.statistics), decreasing = TRUE)
    null.statistics <- abs(null.statistics)
    
    em.pvals <- qvalue::empPvals(test.statistics, null.statistics)
    qvals <- rep(1, length(em.pvals))
    tryCatch({
      qvals <- qvalue::qvalue(em.pvals)$qvalue
    }, error = function(e) {
      # if pi0, the estimated proportion of true null hypothesis <= 0, it might fail: in that case set to zero and return p-values anyways
      qvals <- rep(1, length(em.pvals))
    })
    names(qvals) <- names(test.statistics)
    names(em.pvals) <- names(test.statistics)
    return(list(qvals = qvals, pvals = em.pvals))
  } else {
    stop(paste(" alternative ", alternative, " not implemented yet!"))
  }
}


#' Filter interactions from NES (DIGGIT) scores and corresponding 
#' background-corrected scores. 
#' 
#' Use this version in the Bayes model to rank TFs
#' 
#' @import stats
#' @param corrected.scores A list indexed by the genomic event/gene with 
#' corresponding pvals and qvals for each TF
#' @param nes.scores Matrix with tfs as columns, rows are genomic events
#' @param cindy CINDy algorithm output matrix
#' @param p.thresh P-value threshold (default=0.05)
#' @param cindy.only Consider only CINDy validated interactions (default=TRUE)
#' @return a list (indexed by VIPER protein) of significant genomic interactions 
#' and associated pvals over the background (null TF) model, and NES scores
#' @keywords internal
sigInteractorsDIGGIT <- function(corrected.scores, nes.scores, cindy, 
                                 p.thresh = 0.05, cindy.only = TRUE) {
  
  pvals.matrix <- getPvalsMatrix(corrected.scores)
  
  # input validation
  if (!is.numeric(p.thresh)) {
    stop("Invalid value supplied for p-value threshold!")
  }
  
  ## Apply joint NES + p-value over background (null TF) threshold over each Viper Protein return the raw NES scores only for those significant over the
  ## background and including CINDy (if applicable)
  viper.interactors <- lapply(colnames(pvals.matrix), function(viperProt) {
    
    # find the over-null-TF-background scores with an significant, uncorrected p-value 
    pvals <- as.numeric(pvals.matrix[, as.character(viperProt)])
    nes.vec <- as.numeric(nes.scores[, as.character(viperProt)])
    
    row.idx <- which(pvals < p.thresh)
    pvals <- pvals[row.idx]
    names(pvals) <- rownames(pvals.matrix)[row.idx]
    
    if (!all(names(pvals) == names(nes.vec))) { 
      stop('Data not aligned for aREA / aREA corrected p-values') 
    }
    
    # subset the NES vector for this TF, threshold again on NES scores as a sanity check on the basic enrichment (i.e. remove those with high
    # over-background scores simply because the background is de-enriched)
    nes.vec <- nes.scores[, which(colnames(nes.scores) == as.character(viperProt))]
    nes.vec <- nes.vec[which(2 * (1 - pnorm(abs(nes.vec))) < p.thresh)]
    
    fusion.index <- unlist(lapply(names(nes.vec), function(x) if (length(strsplit(x, "_")[[1]]) > 1) 
      TRUE else FALSE))
    # subset to CINDY validated upstream regulators
    if (cindy.only && is.null(cindy[[viperProt]])) {
      return(c())
    } else if (cindy.only) {
      
      # lookup takes about a second...
      cindy.thisTF <- cindy[[viperProt]]
      
      upstream.cindy.modulators <- names(cindy.thisTF)
      cindy.nes.vec <- na.omit(nes.vec[match(upstream.cindy.modulators, names(nes.vec))])
      if (length(cindy.nes.vec) == 0) {
        return(c())
      }
      
      # add fusions in, they don't have CINDy scores
      fus.vec <- nes.vec[fusion.index]
      entrez.vec <- cindy.nes.vec[which(!is.na(cindy.nes.vec))]
      
      # Independence of these: multiply through
      cindy.entrez.pvals <- cindy.thisTF[(names(cindy.thisTF) %in% names(entrez.vec))]
      entrez.pvals <- 2 * (1 - pnorm(abs(entrez.vec)))
      entrez.pvals <- entrez.pvals * cindy.entrez.pvals
      
      entrez.vec.corrected <- (1 - qnorm(entrez.pvals)) * sign(entrez.vec)
      nes.vec <- c(entrez.vec.corrected, fus.vec)
    }
    
    # keep interactions significant above the null model and with a significant raw aREA score
    nes.vec <- nes.vec[intersect(names(nes.vec), names(pvals))]
    nes.vec <- nes.vec[which(!is.na(nes.vec))]
    
    nes.vec <- sort(nes.vec, decreasing = TRUE)
    nes.vec
  })
  names(viper.interactors) <- colnames(pvals.matrix)
  viper.interactors
}


#' Utility function 
#' 
#' @param corrected.scores - corrected p-values processed by 'qvals' package
#' @return A matrix of p-values for scores between genes/events (rows) and 
#' TFs (columns)
#' @keywords internal
getPvalsMatrix <- function(corrected.scores) {
  # order of VIPER proteins/TFs
  tf.names.order <- names(corrected.scores[[1]]$qvals)
  pvals.matrix <- matrix(unlist(lapply(corrected.scores, function(x) {
    pvals <- x$pvals[tf.names.order]
    pvals
  })), byrow = TRUE, ncol = length(tf.names.order))
  
  colnames(pvals.matrix) <- tf.names.order
  rownames(pvals.matrix) <- names(corrected.scores)
  pvals.matrix
}

utils::globalVariables(c("gene.map"))

#' Convert from entrez ids to hugo gene names
#' @importFrom utils data
#' @param entrez.ids : vector of entrez ids requires hugo2entrez to be loaded
#' @examples
#' mapEntrez(c("29974", "5728"))
#' @seealso \code{\link[MOMA]{mapHugo}}
#' @return : vector of hugo gene names
#' @export
mapEntrez <- function(entrez.ids) {
  utils::data("gene.map")
  # make sure no empty spaces around the entrez ids
  entrez.ids <- gsub(" ", "", entrez.ids)
  idx <- match(as.character(entrez.ids), as.character(gene.map$Entrez.IDs))
  mapped <- gene.map$Gene.Symbol[idx]
  
  if(sum(is.na(mapped)) > 0 ) {
    message("Some entrez ids not mapped to genenames! Replaced with their original input")
    na.idx <- which(is.na(mapped))
    for (na in na.idx) {
      old.name <- entrez.ids[na]
      mapped[na] <- old.name
    }
  }
  
  return(as.character(mapped))
}



#' Convert from hugo gene names to entrez ids
#' @importFrom utils data
#' @param hugo.ids : vector of hugo gene names, requires hugo2entrez to be loaded
#' @examples
#' mapHugo(c("A1CF","PTEN"))
#' @seealso \code{\link[MOMA]{mapEntrez}}
#' @return : vector of entrez ids 
#' @export
mapHugo <- function(hugo.ids) {
  utils::data("gene.map")
  idx <- match(hugo.ids, gene.map$Gene.Symbol)
  mapped <- gene.map$Entrez.IDs[idx]
  
  if(sum(is.na(mapped)) > 0 ) {
    message("Some genenames not mapped to entrez ids! Replaced with their original input")
    na.idx <- which(is.na(mapped))
    for (na in na.idx) {
      old.name <- hugo.ids[na]
      mapped[na] <- old.name
    }
  }
  return(as.character(mapped))
}

test_that("mapEntrez works", {
  expect_identical(mapEntrez(c("A1BG", "A1CF")), c("A1BG", "A1CF"))
  expect_identical(mapEntrez(c("1", "29974")), c("A1BG", "A1CF"))
})

test_that("mapHugo works", {
  expect_identical(mapHugo(c("A1BG", "A1CF")), c("1", "29974"))
  expect_identical(mapHugo(c("1", "29974")), c("1", "29974"))
})

library(dplyr)
library(readr)

raw <- read_tsv("data-raw/hgnc.gene.information.txt", col_types = "cccc")
colnames(raw) <- c("Gene.Symbol", "Cytoband", "Entrez.IDs","Ensembl")

gene.map <- raw %>% select(Gene.Symbol, Entrez.IDs, Cytoband, Ensembl)
gene.map <- as.data.frame(gene.map)

usethis::use_data(gene.map)

#' Main function to generate the summary plots of the analysis
#' @import ComplexHeatmap
#' @import circlize
#' @import grid
#' @param momaObj : momaObj that has already run the saturationCalculation function
#' @param clustering.solution : clustering vector with sample names and cluster designations
#' @param important.genes : vector of gene names to prioritize when plotting. 
#' Can be general genes of interest, oncogenes, tumor supressors etc
#' @param fCNV : vector of confirmed functional CNVs if calculated. Will filter for only those CNVs
#' @param max.events : maximum number of events to plot for the oncoplots
#' @return object with both types of summary plot for each subtype
#' @examples 
#' 
#' \dontrun{
#' makeSaturationPlots(momaObj, max.events = 20)
#' }
#' @export
makeSaturationPlots <- function(momaObj, clustering.solution = NULL, 
                                important.genes = NULL, fCNV = NULL, 
                                max.events = 30) {
  
  # check for required components of previous saturation analysis and set as local variables
  if (length(momaObj$checkpoints) == 0) {
    stop("Genomic Saturation analysis has not been done. Run momaObj$saturationCalculation() before continuing.
         Quitting...")
  }
  
  checkpoints <- momaObj$checkpoints
  genomic.saturation <- momaObj$genomic.saturation
  
  # get clustering solution to use for calculations. should be provided or previously saved in the momaObj
  if (is.null(clustering.solution)) {
    if (length(momaObj$sample.clustering) == 0) {
      stop("No clustering solution provided. Provide one as an argument or save one
                to the momaObj. Quitting...")
    } else {
      clustering.solution <- momaObj$sample.clustering
    }
  }
  
  # make gene to cytoband location mapping
  band2gene <- momaObj$gene.loc.mapping$Gene.Symbol
  names(band2gene) <- momaObj$gene.loc.mapping$Cytoband
  
  
  
  ###########################
  # Get raw input mutation/cnv/fusion matrices  
  # from the momaObj and prep for oncoprint plots   
  ##########################
  
  # Mutations
  snpmat <- momaObj$mut
  snpmat[snpmat == 1] <- "mut"
  snpmat[snpmat == 0] <- NA
  rownames(snpmat) <- mapEntrez(rownames(snpmat))
  
  # Fusions if they exist
  fusions.mat <- NULL
  if(!is.na(momaObj$fusions[1,1])) {
    fusions.mat <- momaObj$fusions
    fusions.mat[fusions.mat == 1] <- "fus"
    fusions.mat[fusions.mat == 0] <- NA
  }
  
  # CNVs. Input should be GISITC scores so separate into high/low events
  # Filter to only keep fCNVs if provided
  cnv <- momaObj$cnv
  if(!is.null(fCNV)){
    cnv <- cnv[na.omit(match(fCNV, rownames(cnv))),]
    if(nrow(cnv) == 0) {
      stop("CNV matrix after functional CNV filtering is empty. 
           Check that names are in same format or if too many fCNVs are provided.
           Quitting...")
    }
  }
  
  amps <- dels <- cnv
  
  amps[amps < 0.5] <- NA
  amps[amps >= 0.5] <- "amp"
  
  dels[dels > -0.5] <- NA
  dels[dels <= -0.5] <- "del"
  
  
  rownames(amps) <- rownames(dels) <- mapEntrez(rownames(cnv))
  
  ##########################
  # Restructure saturation data 
  # to prep for plotting
  ##########################
  
  
  # get subtype event tables
  subtype.tables <- getSubtypeEventTables(genomic.saturation, clustering.solution, checkpoints)
  
  # get summary table of unique events added in for each regulator 
  ## could be clarified/improved
  ## also potential improvement: look for inflection points of huge jumps of new unique events and highlight those regulators in particular?
  tissue.coverage.df <- mergeDataBySubtype(genomic.saturation, clustering.solution, 100)
  
  
  # initalize object to save plots in
  tmp.oncoplots <- list()
  tmp.curveplots <- list()
  
  if(!is.null(important.genes)) {
    message("List of important genes has been provided. Will prioritize plotting these events first")
  }
  
  for(k in seq_along(subtype.tables)) {
    
    ###########
    # Oncoprint Events Plots
    ###########
    samples.thisCluster <- names(clustering.solution[clustering.solution == k])
    message("")
    message("Number of samples in cluster ", k, ": ", length(samples.thisCluster))
    
    # subset genomic event matrices for this cluster
    snpmat.thisClus <- snpmat[,colnames(snpmat) %in% samples.thisCluster]
    #cnv.thisClus <- cnv[,colnames(cnv) %in% samples.thisCluster]
    amps.thisClus <- amps[,colnames(amps) %in% samples.thisCluster]
    dels.thisClus <- dels[,colnames(dels) %in% samples.thisCluster]
    fusions.thisClus <- NULL
    if (!is.null(fusions.mat)) {	
      fusions.thisClus <- fusions.mat[,colnames(fusions.mat) %in% samples.thisCluster]
      if(ncol(fusions.thisClus) == 0) {
        fusions.thisClus <- NULL
      }
    }
    
    p.oncoprint <- oncoprintPlot(summary.vec = subtype.tables[[k]], snpmat.thisClus, amps.thisClus, dels.thisClus, fusions.thisClus, 
                                 important.genes, band2gene, max.events, k)
    tmp.oncoplots[[k]] <- p.oncoprint
    
    #########
    # Saturation Curve Plots
    #########
    p.coverage <- genomicPlotSmall(tissue.coverage.df, fraction=0.85, tissue.cluster=k)
    tmp.curveplots[[k]] <- p.coverage
    
  }
  
  list("oncoprint.plots" = tmp.oncoplots, "curve.plots" = tmp.curveplots)
  
}










#' Helper function to get subtype specific events
#' @param saturation.data : genomic saturation object from MOMA. List indexed by 
#' cluster then sample then regulator with the number of events associated with 
#' each additional regulator
#' @param sample.clustering : clustering vector with sample names and 
#' cluster designations
#' @param checkpoints : from momaObj
#' @return a table that has counts of how many times a particular event 
#' happens in a cluster
#' @keywords internal
getSubtypeEventTables <- function(saturation.data, sample.clustering, 
                                  checkpoints) {
  
  subtype.coverage <- list()
  coverage.allSubtypes <- saturation.data
  clustering <- sample.clustering
  
  # aggregate statistics across all samples, but use different subtype 
  # specific solutions
  for (cluster.id in unique(clustering)) {
    # dataframe with sample, type, gene names for each 
    # amp/del events can be locations. 
    coverage <- coverage.allSubtypes[[cluster.id]]
    sample.set <- names(coverage)
    
    # get number of regulators decided for this checkpoint depending on threshold 
    mr.cutoff <- length(checkpoints[[cluster.id]])
    
    #if (isTRUE(checkpoint.spec)) {
    #mr.cutoff <- length(momaObj$checkpoints.clusterSpecific[[cluster.id]])
    #} else {
    # mr.cutoff <- length(momaObj$checkpoints[[cluster.id]])
    #}
    
    subtype.coverage[[cluster.id]] <- makeCoverageDf(coverage, cutoff=mr.cutoff)
    
  }
  names(subtype.coverage) <- unique(clustering)
  
  # make summary table that counts the number of events in the group
  subtype.tables <- lapply(names(subtype.coverage), function(cluster.id) {
    table(apply(subtype.coverage[[cluster.id]], 1, function(x) paste0(x[1], ':', x[2])))
  })
  subtype.tables
}


#' Helper function for making the coverage dataframe 
#' @param coverage.list : List indexed by sample name, 
#' contains mut/fus/amp/del interactions
#' @param cutoff : number of regulators to include
#' @return dataframe with each sample and which events are 
#' captured by the checkpoint mrs
#' @keywords internal
makeCoverageDf <- function(coverage.list, cutoff) {
  
  df <- c()
  for (name in names(coverage.list)) {
    # skip empty/missing sample data
    if (is.null(coverage.list[[name]])) { next }
    
    for (type in c("mut", "amp", "del", "fus")) {
      
      events.thisSample <- coverage.list[[name]][[cutoff]][[type]]
      if (is.null(events.thisSample)) {
        non.null.idx <- which(vapply(coverage.list[[name]], 
                                     function(x) !is.null(x), 
                                     FUN.VALUE = logical(1))) ## ??
        real.cutoff <- max(non.null.idx[non.null.idx < cutoff])
        events.thisSample <- coverage.list[[name]][[real.cutoff]][[type]]
      }
      
      CT <- length(events.thisSample)
      if (CT==0) { next }
      submat <- cbind(rep(name, CT), rep(type, CT), events.thisSample)
      df <- rbind(df, submat)
    }
  }
  
  df <- data.frame(event=df[,3], type=df[,2], sample=df[,1])
  df	
}


#' Create data frame from coverage data, including number of total events 
#' 'covered' and unique events
#' @param genomic.saturation : data from genomic saturation function
#' @param sample.clustering : clustering vector with sample names and 
#' cluster designations
#' @param topN : number of regulators to look through. default is 100
#' @return dataframe with coverage data for genomic events
#' @keywords internal
mergeDataBySubtype <- function(genomic.saturation, sample.clustering, 
                               topN = 100)  {
  
  # generate summary stats for each subtype	
  full.df <- c()
  for (subtype in unique(sample.clustering)) {	
    
    # unnecessary 
    # subtype.samples <- names(sample.clustering[sample.clustering==subtype])
    coverage.subtype <- genomic.saturation[[subtype]]
    df <- mergeData(coverage.subtype, topN)
    
    # append a column specifying the subtype	
    df$subtype <- rep(subtype, nrow(df))
    full.df <- rbind(full.df, df)
  }
  
  full.df
}


#' Helper function for mergeDataBySubtype
#' @param coverage.range : genomic saturation for a particular subtype
#' @param topN : max number of top regulators to search through
#' @return dataframe with coverage data for genomic events
#' @keywords internal
mergeData <- function(coverage.range, topN)  {
  
  data <- c()
  for (i in seq_len(topN)) {
    # count for each sample
    # $mut/amp/del all point to either a NA or a vector of names of the event. If NA the length will be zero
    # so simply count the number of each type of event 
    count <- unlist(lapply(coverage.range, function(x) {
      num.events <- length(x[[i]]$mut)+length(x[[i]]$amp)+length(x[[i]]$del)
    }))
    count <- na.omit(count)
    
    # apply over each sample, get the coverage for each
    fraction <- unlist(lapply(coverage.range, function(x) {
      # critically: must omit the NAs so they don't interfere with count
      event.fractions <- x[[i]]$total.frac
      event.fractions
    }))
    fraction <- na.omit(fraction)
    
    all.events <- unlist(lapply(coverage.range, function(x) {
      c(x[[i]]$mut, x[[i]]$amp, x[[i]]$del)
    }))
    all.events <- na.omit(all.events)
    
    data <- rbind(data, c(i, mean(count), mean(fraction), length(unique(all.events))))
  }
  df <- data.frame(mean=data[,2], k=data[,1], fraction=data[,3], unique.events=data[,4]) 
  df	
}


#' Function to plot genomic events in the style of oncoPrint/cBioPortal
#' @importFrom tidyr separate
#' @importFrom dplyr arrange select mutate mutate_all everything bind_rows group_by n desc
#' @importFrom tibble deframe as_tibble rownames_to_column tibble column_to_rownames
#' @importFrom stringr str_split_fixed
#' @importFrom rlang .data
#' @importFrom grid textGrob
#' @param summary.vec : named vector of the counts, named 'Event name':'Type'
#' where type is 'mut', 'amp', 'del', 'fus'. Mutations are in Entrez ID
#' Amp/Deletion CNV events are in genomic band location
#' @param snpmat.thisClus : SNP matrix subset to samples in current cluster
#' @param amps.thisClus : CNV matrix subset to samples in current cluster (just amplifications)
#' @param dels.thisClus : CNV matrix subset to samples in current cluster (just deletions)
#' @param fusions.thisClus : Fusion matrix subset to samples in current cluster
#' @param important.genes : well known genes to highlight in the analysis
#' @param band2gene : mapping of genomic location IDs to gene name: vector of 
#' HUGO gene ids, named by genomic location
#' @param max.events : maximum number of events to plot for the oncoplots
#' @param k : current cluster number
#' @return oncoprint event plot
#' @keywords internal
oncoprintPlot <- function(summary.vec, snpmat.thisClus, amps.thisClus, 
                          dels.thisClus, fusions.thisClus, important.genes, 
                          band2gene, max.events, k) {
  
  data <- data.frame(coverage=names(summary.vec), freq=as.numeric(summary.vec)) %>%
    tidyr::separate(.data$coverage, c("id", "type"), ":", remove = FALSE) %>%
    dplyr::arrange(dplyr::desc(.data$freq))
  
  ## Split into separate data types
  mut.data <- data[data$type == "mut",] %>% 
    dplyr::mutate(id = mapEntrez(.data$id)) %>% 
    dplyr::select(.data$id, .data$freq) %>% 
    tibble::deframe()
  
  amp.data <- data[data$type == "amp",] %>%
    dplyr::select(.data$id, .data$freq) %>% 
    dplyr::mutate(gene = NA)
  
  del.data <- data[data$type == "del",] %>%
    dplyr::select(.data$id, .data$freq) %>% 
    dplyr::mutate(gene = NA)
  
  fus.data <- data[data$type == "fus",] %>% 
    dplyr::select(.data$id, .data$freq) %>% 
    tibble::deframe()
  
  
  if(is.null(important.genes)) {
    # if no list of important genes has been provided just plot top events
    
    # subset mutations by name
    mut.mat <- tibble::as_tibble(snpmat.thisClus[names(mut.data),], rownames = NA) %>% 
      tibble::rownames_to_column(var = "genomic.event") %>% 
      dplyr::mutate(type = "mut") %>% 
      dplyr::mutate_all(as.character) %>% 
      dplyr::select(.data$genomic.event, .data$type, dplyr::everything())
    
    # for each cytoband region subset the genes in that region and get the gene 
    # with the highest number of events to represent it
    
    # amplifications 
    for(row in seq_len(nrow(amp.data))) {
      cnv.loc <- amp.data$id[row]
      genes.inBand <- as.character(band2gene[which(names(band2gene)==cnv.loc)])
      band.mat <- amps.thisClus[intersect(genes.inBand, rownames(amps.thisClus)),]
      if(is.null(nrow(band.mat))) { 
        # only one gene case, just use that one
        amp.data$gene[row] <- intersect(genes.inBand, rownames(amps.thisClus))
      } else {
        rank.events <- apply(band.mat, 1, function(x) sum(!is.na(x))) %>% sort(decreasing = TRUE)  
        # take the one with most events cause sometimes genes in the band won't all have same score
        amp.data$gene[row] <- names(rank.events)[1]
      }
      
    }
    
    amps.mat <- amps.thisClus[amp.data$gene, ]
    amps.mat <- cbind(genomic.event = amp.data$id, type = rep("amp", nrow(amps.mat)), amps.mat) %>% 
      as.data.frame(stringsAsFactors = FALSE)
    
    # deletions
    for(row in seq_len(nrow(del.data))) {
      cnv.loc <- del.data$id[row]
      genes.inBand <- as.character(band2gene[which(names(band2gene)==cnv.loc)])
      band.mat <- dels.thisClus[intersect(genes.inBand, rownames(dels.thisClus)),]
      if(is.null(nrow(band.mat))) { 
        # only one gene case, just use that one
        del.data$gene[row] <- intersect(genes.inBand, rownames(dels.thisClus))
      } else {
        rank.events <- apply(band.mat, 1, function(x) sum(!is.na(x))) %>% sort(decreasing = TRUE)  
        # take the one with most events cause sometimes genes in the band won't all have same score
        del.data$gene[row] <- names(rank.events)[1]
      }
      
    }
    
    dels.mat <- dels.thisClus[del.data$gene, ]
    dels.mat <- cbind(genomic.event = del.data$id, type = rep("del", nrow(dels.mat)), dels.mat) %>%
      as.data.frame(stringsAsFactors = FALSE)
    
    # fusions
    
    if(!is.null(fusions.thisClus) & length(fus.data) > 0) {
      fus.mat <- tibble::as_tibble(fusions.thisClus[names(fus.data),], rownames = NA) %>% 
        tibble::rownames_to_column(var = "genomic.event") %>% 
        dplyr::mutate(type = "fus") %>% 
        dplyr::mutate_all(as.character) %>% 
        dplyr::select(.data$genomic.event, .data$type, dplyr::everything())
    } else {
      fus.mat <- NULL
    }
    
    
    mat.to.plot <- dplyr::bind_rows(mut.mat, amps.mat, dels.mat, fus.mat)
    
  } 
  
  
  # merge rows that are duplicated (have muts and amp/dels)
  dups.count <- mat.to.plot %>% dplyr::group_by(.data$genomic.event) %>% 
    dplyr::summarise(n = dplyr::n())
  dups.count <- dups.count[dups.count$n > 1, 1]
  dups <- mat.to.plot[mat.to.plot$genomic.event %in% dups.count$genomic.event,]
  
  
  if(nrow(dups) > 0 ) {
    dups.names <- unique(dups$genomic.event)
    # remove duplicates from the current matrix
    mat.to.plot <- mat.to.plot[!mat.to.plot$genomic.event %in% dups.count$genomic.event,]
    for (name in dups.names) {
      # collapse all types of events together into one row and then rebind to main matrix
      # having NA;event is fine syntax for use in oncoprint function
      #### added in function to keep amps and dels separate, only merge mut with amps/dels
      
      merged <- dups[dups$genomic.event == name,]
      if(!"mut" %in% merged$type) {
        # means that only events are amps/dels, don't merge. 
        # add a/d to the end do be able to differentiate later 
        # (and to not run into issue of duplicate rownames in the matrix)
        merged$genomic.event <- paste(merged$genomic.event, merged$type, sep = "_")
      } else if ("mut" %in% merged$type & nrow(merged) == 2) {
        # means that one event is a mut and other is amp/del
        # merge together like before by collapsing the rows together
        merged <- apply(merged, 2, paste0, collapse = ";")
        merged[1] <- name
      } else if (nrow(merged) == 3) {
        # means that there is one of each type of event mut, amp and del
        # merge mut with amp and del separately
        
        amp.merged <- merged[merged$type %in% c("amp", "mut"),] %>% apply(2, paste0, collapse = ";")
        amp.merged[1] <- paste(name, "amp", sep = "_")
        
        del.merged <- merged[merged$type %in% c("del", "mut"),] %>% apply(2, paste0, collapse = ";")
        del.merged[1] <- paste(name, "del", sep = "_")
        
        merged <- dplyr::bind_rows(amp.merged, del.merged)
      } else {
        stop("Problem merging duplicates, double check gene names.")
      }
      
      mat.to.plot <- dplyr::bind_rows(mat.to.plot, merged)
    }
  }
  
  # replace new NA's with regular ones so that plots can be counted for events again
  mat.to.plot[mat.to.plot == "NA;NA"] <- NA
  mat.to.plot[mat.to.plot == "NA;NA;NA"] <- NA
  
  # get row sums, in terms of events and take top ones. filter for events that happen at least twice here
  mat.to.plot <- mat.to.plot %>% dplyr::select(-.data$type) %>%
    tibble::column_to_rownames(var = "genomic.event") %>% 
    as.matrix()
  num.events <- apply(mat.to.plot, 1, function(x) sum(!is.na(x))) %>% sort(decreasing = TRUE) 
  num.events <- num.events[num.events > 1] 
  
  # add events in chunks of frequency until max is reached
  final.mat <- matrix(nrow = 0, ncol = ncol(mat.to.plot))
  freq.range <- unique(num.events)
  freq.idx <- 1
  while(nrow(final.mat) < max.events & freq.idx <= length(unique(num.events))) {
    to.add <- names(num.events[num.events == freq.range[freq.idx]])
    to.add.mat <- matrix(mat.to.plot[to.add,], nrow = length(to.add), dimnames = list(rownames = to.add))
    # final.mat <- rbind(final.mat, to.add.mat)
    new.final.mat <- rbind(final.mat, to.add.mat)
    if(nrow(new.final.mat) > max.events) {
      break
    } else {
      final.mat <- new.final.mat
    }
    freq.idx <- freq.idx + 1
  }
  
  # check if all genes are unique (as per merging of muts with amps/dels)
  # if so remove _cnv ending, else leave it on
  
  final.plot.names <- stringr::str_split_fixed(rownames(final.mat), pattern = "_", n = 2)
  if(length(unique(final.plot.names[,1])) == nrow(final.mat)) {
    rownames(final.mat) <- final.plot.names[,1]
  }
  
  message("Plotting ", nrow(final.mat), " total events for subtype ")
  
  if(nrow(final.mat) == 0) {
    return(grid::textGrob("No significant events to plot for this subtype"))
  }
  
  
  ##########
  # Heatmap plot
  #########
  
  
  heatmap_legend_param = list(title = "Alterations", 
                              at = c("amp", "del", "mut", "fus"), 
                              labels = c("Amplification", "Deletion", "Mutation", "Fusion"))
  
  
  # color parameters for oncoprint
  col = c("del" = "blue", "amp" = "red", "mut" = "#008000", "fus" = 'gold2', "NA" = "grey22")
  alter_fun = list(
    background = function(x, y, w, h) {
      grid.rect(x, y, w*0.6, h*0.75, 
                gp = gpar(fill = "#CCCCCC", col = NA))
    },
    # big blue - dels
    del = function(x, y, w, h) {
      grid.rect(x, y, w*0.6, h*0.75, 
                gp = gpar(fill = col["del"], col = NA))
    },
    # big red - amps
    amp = function(x, y, w, h) {
      grid.rect(x, y, w*0.6, h*0.75, 
                gp = gpar(fill = col["amp"], col = NA))
    },
    
    # small green
    mut = function(x, y, w, h) {
      grid.rect(x, y, w*0.6, h*0.33, 
                gp = gpar(fill = col["mut"], col = NA))
    },
    
    # big yellow
    fus = function(x, y, w, h) {
      grid.rect(x, y, w*0.6, h*0.75, 
                gp = gpar(fill = col["fus"], col = NA))
    }
  )
  
  # optimize size of labels
  if(nrow(final.mat) >= 55) {
    label.size <- 3
  } else if (nrow(final.mat) >= 40 ) {
    label.size <- 4
  } else if (nrow(final.mat) >= 30) {
    label.size <- 5
  } else if (nrow(final.mat) >= 20) {
    label.size <- 6
  } else {
    label.size <- 7
  }
  
  
  title <- paste("Genomic Events for Subtype", k)
  
  # set NAs to empty string in final mat to avoid Complex Heatmap warning
  final.mat[is.na(final.mat)] <- ""
  
  ht <- ComplexHeatmap::oncoPrint(final.mat,
                                  alter_fun = alter_fun, col = col,
                                  heatmap_legend_param = heatmap_legend_param,
                                  pct_side = "right", pct_gp = gpar(fontsize = label.size),
                                  column_title = title, column_title_gp = gpar(fontsize = 8),
                                  row_names_side = "left", row_names_gp = gpar(fontsize = label.size),
                                  show_heatmap_legend = TRUE,
                                  top_annotation = HeatmapAnnotation(
                                    column_barplot = anno_oncoprint_barplot(height = unit(.4, "cm"), axis_param = list(gp = gpar(fontsize = 4)))),
                                  right_annotation = rowAnnotation(
                                    row_barplot = anno_oncoprint_barplot(width = unit(1, "cm"), axis_param = list(gp = gpar(fontsize = 5)))))
  
  
  
  p <- grid::grid.grabExpr(draw(ht, padding = unit(c(0, 0, 0, 0), "mm")))
  
  p
  
}







##### No longer the primary plot style but keeping as an option plot style
##### TODO: Need to make it a freestanding function
#' Plot barchart of genomic events 
#' 
#' @importFrom rlang .data
#' @param summary.vec : named vector of the counts, named 'Event name':'Type'
#' where type is 'mut', 'amp', 'del', 'fus'. Mutations are in Entrez ID
#' Amp/Deletion CNV events are in genomic band location
#' @param highlight.genes : well known genes to highlight in the analysis in 
#' @param genomeBand_2_gene : mapping of genomic location IDs to gene name: 
#' vector of HUGO gene ids, named by genomic loci
#' @param samples.total : number of samples in the subtype, used to calculate percentages
#' @param max.muts : maximum number of mutations to get per sample, default is 10
#' @param max.cnv : maximum number of cnvs to per sample, default is 5
#' @return plot object
#' @keywords internal 
plotEvents <- function(summary.vec, highlight.genes=NULL, genomeBand_2_gene=NULL,
                       samples.total, max.muts = 10, max.cnv = 5) {
  
  data <- data.frame(coverage=names(summary.vec), Freq=as.numeric(summary.vec))
  # order by individual frequency
  data <- data[order(-data$Freq),]
  
  data$id <- unlist(lapply(data$coverage, function(label) {
    label <- as.character(label)
    name <- strsplit(label, ':')[[1]][1]
    hugo <- mapEntrez(as.character(name))
    if (is.na(hugo)) {
      return (name)
    } else {
      return (hugo)
    }
  }))
  
  # make a new column: for CNV band locations
  data$type <- unlist(lapply(data$coverage, function(label) {
    type <- strsplit(as.character(label), ':')[[1]][2]
    type
  }))
  
  # get order dataframe of events 
  mapped <- getDataFrame(data, highlight.genes, genomeBand_2_gene, max.muts = 10, max.cnv = 5)
  # check the size: if we have too many events to display, then select the top N unique IDs
  # already sorted by frequency of occurence. 
  if (nrow(mapped) > 50) {
    # add at least half simply with mutated gene labels
    mut.data <- mapped[mapped$type=='mut',]
    add.labels <- na.omit(unique(mut.data[order(-mut.data$Freq),][seq_len(25),]$id))
    # and add cnv
    additional <- setdiff(unique(mapped$id), add.labels)[seq_len(50-length(add.labels))]
    mapped <- mapped[mapped$id %in% union(additional, add.labels),]
  }
  
  # The palette with black: (unnecessary?)
  # cbbPalette <- c("#000000", "#E69F00", "#56B4E9", "#009E73", "#F0E442", "#0072B2", "#D55E00", "#CC79A7")
  
  # if exporting as object then just use default of 10 and then change by adding geom/layer when plotting
  # else if plotting directly then try to adjust text size to fit based on number of events
  
  # data.size <- nrow(mapped)
  # if(is.null(output)) {
  #   print("No file output name found, using pre-selected text size for plotting")
  #   y.textSize <- 10
  # } else {
  #   print("Output plot name found, adjusting text size based on number of events")
  #   if (num.subtypes > 5 && data.size > 50) {
  #     y.textSize <- 1
  #   } else if (num.subtypes > 4 && data.size > 25) {
  #     y.textSize <- 2
  #   } else if (num.subtypes > 4 && data.size <= 25) {
  #     y.textSize <- 3
  #   } else if (data.size < 20) {
  #     y.textSize <- 5
  #   } else if (data.size < 40) {
  #     y.textSize <- 6
  #   }
  # }
  
  message('Number of entries in events matrix: ', nrow(mapped))
  #print (paste('Using font size ', y.textSize))
  
  
  # Scale frequency to a percentage of samples in that cluster not number of occurences
  mapped$freq.percentage <- mapped$Freq/samples.total
  
  p <- ggplot2::qplot(x=mapped$id, y=mapped$freq.percentage, fill=mapped$type, data=mapped, geom = "col") + coord_flip() +
    scale_fill_manual(values = c("mut"='#00BA38', "amp"= '#F8766D', "del" = '#619CFF', "fus" = '#FF8C00' )) +
    ylab("Frequency") + xlab("Event") 
  #theme(axis.text.y = element_text(size=y.textSize))
  #labs(title=label) 
  
  # if (!is.null(output)) {
  #   p <- p + labs(title = paste(plot.label, "subtype", k))
  #   ggsave(output)
  # }
  
  p
}



#' Helper function to get data frame for bar plot plot.events function

#' @param data data.frame with $type, $id, $Freq per event
#' @param highlight.genes genes to look for in mutations/cnv lists (if looking
#'  for specific genes because of prior knowledge)
#' @param genomeBand_2_gene mapping of genomic location IDs to gene name: 
#' vector of HUGO gene ids, named by genomic loci
#' @param max.muts maximum number of mutations to get per sample, default is 10
#' @param max.cnv maximum number of cnvs to per sample, default is 5
#' @return ordered data frame with each genomic event and it's frequency
#' @keywords internal
getDataFrame <- function(data, highlight.genes, genomeBand_2_gene, 
                         max.muts = 10, max.cnv = 5) {
  
  #### edit logic of this section ?
  
  
  MAX.muts <- max.muts
  MAX.CNV.loc <- max.cnv
  ## all all highlight genes and events to the 
  
  ## for each CNV location event, find genes that overlap with the highlight list. 
  ## add duplicate entries for those genes
  mapped <- c()
  loc.data <- data[data$type=='del',]
  for (row in seq_len(nrow(loc.data))) {
    loc <- loc.data[row, 3]
    genes.inBand <- as.character(genomeBand_2_gene[which(names(genomeBand_2_gene)==loc)])
    hgIB <- intersect(genes.inBand, highlight.genes)
    
    if (length(hgIB)==0) { next }
    
    mapped <- rbind(mapped, data.frame(coverage=loc.data[row, 1], 
                                       Freq=loc.data[row, 2], 
                                       id=hgIB, 
                                       type=loc.data[row, 4]))
  }
  loc.data <- data[data$type=='amp',]
  for (row in seq_len(nrow(loc.data))) {
    loc <- loc.data[row, 3]
    genes.inBand <- as.character(genomeBand_2_gene[which(names(genomeBand_2_gene)==loc)])
    hgIB <- intersect(genes.inBand, highlight.genes)
    
    if (length(hgIB)==0) { next }
    
    mapped <- rbind(mapped, data.frame(coverage=loc.data[row, 1], 
                                       Freq=loc.data[row, 2], 
                                       id=hgIB, 
                                       type=loc.data[row, 4]))
  }
  
  # find mutations in key regions
  loc.data <- data[data$type=='mut',]
  for (row in seq_len(nrow(loc.data))) {
    gene <- loc.data[row, 3]
    hgIB <- intersect(gene, highlight.genes)
    if (length(hgIB)==0) { next }
    mapped <- rbind(mapped, data.frame(coverage=loc.data[row, 1], 
                                       Freq=loc.data[row, 2], 
                                       id=hgIB, 
                                       ype=loc.data[row, 4]))
  }
  
  # HUGO ids: add additional mutation events outside of the highlight genes
  all.gene.ids <- as.character(mapped$id)
  # add in top X mutations not in the driver list
  mut.data <- data[data$type=='mut',]
  i = 1	
  for (row in seq_len(nrow(mut.data))) {
    if (mut.data[row,]$id %in% all.gene.ids) { next }
    if (i > MAX.muts) { break }
    mapped <- rbind(mapped, mut.data[row,])
    i = 1+i
  }
  
  # add all fusions
  mapped <- rbind(mapped, data[data$type=='fus',])
  
  # add CNV band locations (a few)
  subset <- data[apply(cbind(data$type=='amp', data$type=='del'), 1, any),]
  if (nrow(subset) > MAX.CNV.loc) { subset <- subset[seq_len(MAX.CNV.loc),] }
  mapped <- rbind(mapped, subset)
  
  # order by total frequency of events by gene/id
  mapped$event_sums <- vapply(mapped$id, function(id) { 
    sum(as.numeric(mapped[which(mapped$id==as.character(id)),]$Freq)) }, 
    FUN.VALUE = numeric(1))
  mapped <- mapped[order(-mapped$event_sums),]
  mapped$id <- factor(mapped$id, levels=unique(rev(mapped$id)))
  
  mapped
}


#' Make small genomic plot
#' @importFrom tidyr drop_na
#' @importFrom rlang .data
#' @importFrom grDevices colorRampPalette
#' @import ggplot2
#' @import magrittr
#' @param input.df : tissue.coverage.df with mean, k, fraction and unique events.
#' @param fraction : what fraction coverage to use for genomic curve threshold
#' @param tissue.cluster : which cluster subsample to look at
#' @return output .png
#' @keywords internal
genomicPlotSmall <- function(input.df, fraction=0.85, tissue.cluster=NULL)  { 
  
  #### need to add in null matrix function ###
  
  
  # get number of subtypes and colors for plotting
  num.subtypes <- length(unique(input.df$subtype))
  getPalette <- colorRampPalette(brewer.pal(n = 8, name = "Dark2"))
  subtype.colors <- getPalette(num.subtypes)
  color.this.sub <- subtype.colors[tissue.cluster]
  
  
  subtype.df <- input.df[input.df$subtype == tissue.cluster,] 
  subtype.df <- subtype.df %>% tidyr::drop_na(.data$fraction)
  
  
  sweep <- subtype.df$fraction
  names(sweep) <- sort(unique(subtype.df$k))
  best.k <- fitCurvePercent(sweep, frac=fraction)
  message("Number of MRs in checkpoint: ", best.k)
  
  
  # mean statistic for these samples
  mean.stat <- unlist(lapply(sort(unique(subtype.df$k)), function(k) {
    mean(subtype.df[which(subtype.df$k==k),]$fraction)
  }))
  sweep <- mean.stat
  # Get mean # of samples
  mean.events.stat <- unlist(lapply(sort(unique(subtype.df$k)), function(k) {
    mean(subtype.df[which(subtype.df$k==k),]$mean)
  }))
  names(mean.events.stat) <- sort(unique(input.df$k))
  # the average multiplier across all the bands:
  # use to count the mean number of events on the right side
  y.multiplier <- mean(na.omit(mean.events.stat/mean.stat))
  
  # first make a condensed plot just the first ~100 events
  ymax <- subtype.df[nrow(subtype.df),]$fraction
  
  # make plot
  p.100 <- ggplot(subtype.df, aes(.data$k, .data$fraction)) + geom_line(color = color.this.sub, size=1.5, alpha=0.75) +
    xlab("Number of MRs") +
    scale_y_continuous(
      "Mean Fraction",
      sec.axis = sec_axis(~ . * y.multiplier, name = "Count"),
      limits=c(0,ymax+0.01)
    ) +
    #geom_ribbon(aes(ymin=null.bq, ymax=null.uq), color='#808080', alpha=0.2, linetype=2) +
    geom_vline(xintercept=as.numeric(best.k), linetype=3) +
    xlim(0,100) +
    #labs(title=tissue) +
    theme(axis.text.x = element_text(size=10), axis.text.y = element_text(size=10), legend.position="none")
  
  # return the plot itself
  p.100 
}

#' @title MOMA Object 
#' @description Main class encapsulating the input data and logic of the MOMA algorithm
#' @import stats
#' @import qvalue
#' @import parallel
#' @import reshape2
#' @import MKmisc
#' @import RColorBrewer
#' @import methods
#' @import ggplot2
#' @import magrittr
#' @import graphics
#' @import grDevices
#' @import readr
#' @import tibble
#' @importFrom stringr str_sub
#' @importFrom dplyr mutate select everything bind_rows
#' @field viper matrix of inferred activity score inferred by viper
#' @field mut binary mutation matrix 1 for presence of mutation, 0 for not, NA 
#' if not determined
#' @field cnv matrix of cnv values. Can be binary or a range. 
#' @field fusions binary matrix of fusion events if appliable
#' @field pathways list of pathways/connections to consider as extra evidence 
#' in the analysis
#' @field gene.blacklist character vector of genes to not include because of 
#' high mutation frequency
#' @field output.folder character vector of location to save files if desired
#' @field gene.loc.mapping data frame of gene names, entrez ids and cytoband locations
#' @field nes field for saving Normalized Enrichment Matrices from the associate events step
#' @field interactions field for saving the MR-interactions list
#' @field clustering.results results from clustering are saved here
#' @field ranks results field for ranking of MRs based on event association analysis
#' @field hypotheses results field for saving events that have enough occurences to be considered 
#' @field genomic.saturation results field for genomic saturation analysis
#' @field coverage.summaryStats results field for genomic saturation analysis
#' @field checkpoints results field with the MRs determined to be the checkpoint for each cluster
#' @field sample.clustering field to save sample clustering vector. Numbers are 
#' cluster assignments, names are sample ids
#' @export
Moma <- setRefClass("Moma", fields = 
                      list(viper = "matrix", 
                           mut = "matrix", 
                           cnv = "matrix", 
                           fusions = "matrix", 
                           pathways = "list", 
                           gene.blacklist = "character",
                           output.folder = "character", 
                           gene.loc.mapping = "data.frame", 
                           nes = "list", # result field
                           interactions = "list", # result field
                           clustering.results = "list", # result field
                           ranks = "list", # result field
                           hypotheses = "list", # result field
                           genomic.saturation = "list", # result field
                           coverage.summaryStats = "list", # result field
                           checkpoints = "list", # result field
                           sample.clustering = "numeric" # result field 
                      ), 
                    methods = list(
                      runDIGGIT = function(fCNV = NULL, cnvthr = 0.5, min.events = 4, verbose = FALSE) {
                        "Run DIGGIT association function to get associations for driver genomic events"
                        
                        cnv.local <- NULL
                        if (is.null(fCNV)) {
                          message("No fCNV supplied, using no CNV filter!")
                          cnv.local <- cnv
                        } else {
                          message("fCNV supplied, filtering for only functional CNVs")
                          cnv.local <- cnv[intersect(fCNV, rownames(cnv)), ]
                        }
                        
                        somut <- mut
                        
                        # Define amplifications and deletions
                        amps <- dels <- cnv.local
                        amps[which(amps < cnvthr)] <- 0
                        amps[which(amps >= cnvthr)] <- 1
                        dels[which(dels > -cnvthr)] <- 0
                        dels[which(dels <= -cnvthr)] <- 1
                        
                        # save the exact hypotheses (genes) we're testing, based on MIN.EVENTS
                        
                        temp.amps <- rownames(amps[apply(amps, 1, sum, na.rm = TRUE) >= min.events, ])
                        amps.hypotheses <- temp.amps[which(!(temp.amps %in% gene.blacklist))]
                        amps.mat <- amps[amps.hypotheses,]
                        
                        temp.dels <- rownames(dels[apply(dels, 1, sum, na.rm = TRUE) >= min.events, ])
                        dels.hypotheses <- temp.dels[which(!(temp.dels %in% gene.blacklist))]
                        dels.mat <- dels[dels.hypotheses,]
                        
                        temp.muts <- rownames(somut[apply(somut, 1, sum, na.rm = TRUE) >= min.events, ])
                        muts.hypotheses <- temp.muts[which(!(temp.muts %in% gene.blacklist))]
                        muts.mat <- somut[muts.hypotheses,]
                        
                        
                        # Print info about 
                        if(verbose) {
                          message("Removing ", length(gene.blacklist),
                                  " mutSig blacklist genes from hypothesis testing")
                          
                          amps.removed <- length(temp.amps) - length(amps.hypotheses)
                          message(length(amps.hypotheses), " useable amplifications found. ", 
                                  amps.removed, " removed for being on the gene blacklist.")
                          
                          dels.removed <- length(temp.dels) - length(dels.hypotheses)
                          message(length(dels.hypotheses), " useable deletions found. ", 
                                  dels.removed, " removed for being on the gene blacklist.")
                          
                          muts.removed <- length(temp.muts) - length(muts.hypotheses)
                          message(length(muts.hypotheses), " useable mutations found. ", 
                                  muts.removed, " removed for being on the gene blacklist.")
                        }
                        
                        hypotheses <<- list(mut = muts.hypotheses, del = dels.hypotheses, amp = amps.hypotheses)
                        
                        # do aREA association
                        nes.amps <- associateEvents(viper, amps.mat, min.events = min.events, 
                                                    event.type = "Amplifications",
                                                    verbose = verbose)
                        nes.dels <- associateEvents(viper, dels.mat, min.events = min.events, 
                                                    event.type = "Deletions",
                                                    verbose = verbose)
                        nes.muts <- associateEvents(viper, muts.mat, min.events = min.events, 
                                                    event.type = "Mutations",
                                                    verbose = verbose)
                        
                        nes.fusions <- NULL
                        if (!is.na(fusions[1,1])) {
                          fus.hypotheses <- rownames(fusions[apply(fusions, 1, sum, na.rm = TRUE) >= min.events, ])
                          hypotheses <<- list(mut = muts.hypotheses, del = dels.hypotheses, 
                                              amp = amps.hypotheses, fus = fus.hypotheses)
                          if(!is.na(output.folder)) {
                            write.table(fus.hypotheses, file = paste0(output.folder, "/hypotheses.fusions.txt"), 
                                        quote = FALSE, sep = "\t")
                          }
                          nes.fusions <- associateEvents(viper, fusions, 
                                                         min.events = min.events, 
                                                         event.type = "Fusions",
                                                         verbose = verbose)
                        }
                        
                        # Save aREA results if desired
                        if(!is.na(output.folder)){
                          save(nes.amps, nes.dels, nes.muts, nes.fusions, file = paste0(output.folder, "/aREA.rda"))
                        }
                        # store in the object list
                        nes <<- list(amp = nes.amps, del = nes.dels, mut = nes.muts, fus = nes.fusions)
                      }, 
                      
                      makeInteractions = function(genomic.event.types = c("amp", "del", "mut", "fus"),
                                                  cindy.only = FALSE) {
                        "Make interaction web for significant MRs based on their associated events"
                        
                        # NULL TFs : from the VIPER matrix, calculate p-values of the absolute mean
                        # NES score for each.  (2-tailed test, -pnorm*2).  BH-FDR < 0.05 are sig.
                        # Take everything else as the background model.
                        ranks[["viper"]] <<- viperGetTFScores(viper)
                        sig.tfs <- viperGetSigTFS(ranks[["viper"]])
                        null.TFs <- setdiff(rownames(viper), sig.tfs)
                        message("Found ", length(sig.tfs), " significant TFs from VIPER scores ... ")
                        message("Building background model from ", length(null.TFs), " nulls...")
                        
                        full.type.names <- c("Amplifications", "Deletions", "Mutations", "Fusions")
                        local.interactions = list()
                        for (i in seq_len(4)) {
                          type <- genomic.event.types[i]
                          message("Performing background correction for ", 
                                  full.type.names[i], " NES scores...")
                          nes.thisType <- nes[[type]]
                          if (is.null(nes.thisType)) {
                            next
                          }
                          corrected.scores <- getDiggitEmpiricalQvalues(viper, nes.thisType, 
                                                                        null.TFs)
                          message("Generating final interactions...")
                          local.interactions[[type]] <- sigInteractorsDIGGIT(corrected.scores, 
                                                                             nes[[type]], pathways[["cindy"]], 
                                                                             cindy.only = cindy.only)
                        }
                        
                        interactions <<- local.interactions
                      }, 
                      
                      Rank = function(use.cindy = TRUE, genomic.event.types = c("amp", "del", "mut", "fus"), 
                                      use.parallel = FALSE, cores = 1) {
                        "Rank MRs based on DIGGIT scores and number of associated events"  
                        
                        # ranks from DIGGIT scores
                        integrated.z <- list()
                        for (type in genomic.event.types) {
                          
                          if (is.null(interactions[[type]])) {
                            next
                          }
                          # deletions/amp CNV events need to be corrected for genome location...
                          if (type == "amp" || type == "del") {
                            integrated.z[[type]] <- stoufferIntegrate(interactions[[type]], 
                                                                      gene.loc.mapping)
                          } else {
                            integrated.z[[type]] <- stoufferIntegrate(interactions[[type]], 
                                                                      NULL)
                          }
                        }
                        # generate integrated rankings from additional sources of evidence, 
                        # using CINDy and pathway databases and/or structural databases like PrePPI
                        pathway.z <- list()
                        
                        if(use.parallel) {
                          if(cores <= 1) {
                            stop("Parallel processing selected but a usable number of cores has not
                been chosen. Please enter a number > 1")
                          } else {
                            message("Parallel processing selected, using", cores, "cores")
                          }
                        }
                        
                        for (pathway in names(pathways)) {
                          
                          pathway.z[[pathway]] <- list()
                          # optional: use cindy scores to generate a separate ranking
                          if (pathway == "cindy" && !use.cindy) {
                            next
                          }
                          for (type in genomic.event.types) {
                            if (is.null(interactions[[type]])) {
                              next
                            }
                            pathway.z[[pathway]][[type]] <- pathwayDiggitIntersect(interactions[[type]], 
                                                                                   pathways[[pathway]], pos.nes.only = TRUE, cores)
                          }
                        }
                        
                        viper.scores <- ranks[["viper"]]
                        message("Integrating all data in Bayesian conditional model...")
                        ranks[["integrated"]] <<- conditionalModel(viper.scores, 
                                                                   integrated.z, 
                                                                   pathway.z)
                      }, 
                      
                      Cluster = function(clus.eval = c("reliability", "silhouette"), use.parallel = FALSE, cores = 1) {
                        "Cluster the samples after applying the MOMA weights to the VIPER scores"
                        
                        if(use.parallel) {
                          if(cores <= 1) {
                            stop("Parallel processing selected but multiple number of cores have not
                  been chosen. Please enter a number > 1")
                          } else {
                            message("Parallel processing selected, using ", cores, " cores")
                          }
                        }
                        
                        # do weighted pearson correlation, using the ranks as weights
                        weights <- log(ranks[["integrated"]])^2
                        weights <- weights[as.character(rownames(viper))]
                        w.vipermat <- weights * viper
                        message("using pearson correlation with weighted vipermat")
                        dist.obj <- MKmisc::corDist(t(w.vipermat), method = "pearson")
                        message("testing clustering options, k = 2..15")
                        search.results <- clusterRange(dist.obj, range = as.numeric(c(2, 15)), 
                                                       step = 1, cores = cores, method = "pam")
                        clustering.results <<- search.results
                        
                        # save the solution with the highest reliability/silhouette to the object
                        clus.eval <- match.arg(clus.eval)
                        if(clus.eval == "reliability"){
                          top.sol <- which.max(search.results$all.cluster.reliability)
                          sample.clustering <<- search.results[[top.sol]]$clustering
                        } else if (clus.eval == "silhouette") {
                          top.sol <- which.max(search.results$all.sil.avgs)
                          sample.clustering <<- search.results[[top.sol]]$clustering
                        } else {
                          stop('Invalid clustering evaluation method provide. Choose either "reliability" or "silhouette"')
                        }
                        
                        message("Using ", clus.eval, " scores to select best solution.")
                        message("Best solution is: ", names(top.sol))
                        
                      }, 
                      
                      saturationCalculation = function(clustering.solution = NULL, cov.fraction = 0.85, 
                                                       topN = 100, verbose = FALSE) {
                        "Calculate the number of MRs it takes to represent the desired coverage fraction of events"
                        
                        # get clustering solution to use for calculations
                        if (is.null(clustering.solution)) {
                          if(is.null(sample.clustering)) {
                            stop("No clustering solution provided. Provide one as an argument or save one to the Moma Object. Quitting...")
                          } else {
                            clustering.solution <- sample.clustering
                          }
                        }
                        
                        # make sure submitted clustering solution has sufficiently large clusters (at least 5 samples)
                        clus.sizes <- table(clustering.solution) < 5
                        
                        if(any(clus.sizes)) {
                          stop("At least one cluster does not have sufficient samples. Select a different clustering solution and resave to object")
                        }
                        
                        # get coverage for each subtype
                        coverage.subtypes <- list()
                        tmp.summaryStats <- list()
                        tmp.checkpoints <- list()
                        for (clus.id in unique(clustering.solution)) {
                          
                          message("Analyzing cluster ", clus.id, " coverage using the top ", 
                                  topN, " regulators")
                          viper.samples <- colnames(viper[, names(clustering.solution[clustering.solution == clus.id])])
                          
                          # Get subtype-specific rankings: use the main rank and include only those with high mean score
                          stouffer.zscores <- apply(viper[, viper.samples], 1, function(x) {
                            sum(na.omit(x))/sqrt(length(na.omit(x)))
                          })
                          pvals <- pnorm(sort(stouffer.zscores, decreasing = TRUE), lower.tail = FALSE)
                          sig.active.mrs <- names(pvals[p.adjust(pvals, method = "bonferroni") < 0.01])
                          
                          # ranked list of cMRs for this subtype
                          subtype.specific.MR_ranks <- sort(ranks[["integrated"]][sig.active.mrs])
                          
                          # calculate per sample event coverage
                          coverage.range <- getCoverage(.self, names(subtype.specific.MR_ranks), 
                                                        viper.samples, topN = topN, verbose = verbose)
                          coverage.subtypes[[clus.id]] <- coverage.range
                          
                          # 'solve' the checkpoint for each subtype
                          
                          # 1) generate summary stats for mean fractional coverage
                          tmp.summaryStats[[clus.id]] <- mergeGenomicSaturation(coverage.range, 
                                                                                topN = topN)
                          # compute best K based on fractional coverage
                          sweep <- tmp.summaryStats[[clus.id]]$fraction
                          names(sweep) <- tmp.summaryStats[[clus.id]]$k
                          best.k <- fitCurvePercent(sweep, frac = cov.fraction)
                          # pick the top cMRs based on this
                          tmp.checkpoints[[clus.id]] <- names(subtype.specific.MR_ranks[seq_len(best.k)])
                        }
                        genomic.saturation <<- coverage.subtypes
                        coverage.summaryStats <<- tmp.summaryStats
                        checkpoints <<- setNames(tmp.checkpoints, seq_along(tmp.checkpoints))
                      },
                      saveData = function(.self, output.folder, ...) {
                        inputs <- unlist(list(...))
                        if(length(inputs) == 0){
                          message("No specific data selected to save. Saving all...")
                          to.save <- c("nes", "interactions", "clustering.results",
                                       "sample.clustering","ranks", "hypotheses", 
                                       "genomic.saturation","coverage.summaryStats", "checkpoints")
                        } else {
                          to.save <- intersect(inputs, c("nes", "interactions", "clustering.results", "sample.clustering",
                                                         "ranks", "hypotheses", "genomic.saturation",
                                                         "coverage.summaryStats", "checkpoints"))
                          
                          if(length(to.save) == 0){
                            stop("Incorrect names supplied. Make sure names match the names of the results fields in the Moma Class.")
                          } else {
                            message("Saving the following: ", paste(to.save, collapse = " "))
                          }
                          
                        }
                        
                        # check if output.folder name ends in / or \\ or not
                        if(!stringr::str_sub(output.folder, start = -1) %in% c("/", "\\")){
                          stop("Output folder does not end with a slash")
                        }
                        
                        # check if directory exists if not create it
                        if(!dir.exists(output.folder)){
                          dir.create(output.folder)
                        }
                        
                        ### create files
                        for(name in to.save) {
                          
                          # confirm that result exists before trying to save
                          if(length(.self[[name]]) == 0) {
                            message("No results found for ", name, ". Skipping...")
                            next
                          }
                          
                          # save nes matrices as tables
                          if(name == "nes"){
                            for (type in names(.self[[name]])) {
                              write.table(.self[[name]][[type]], 
                                          file = paste0(output.folder, type, ".", name, ".txt"), 
                                          quote = FALSE, sep = "\t", col.names = NA)
                            }
                          }
                          
                          # save interactions as 3 separate dfs 
                          if(name == "interactions"){
                            for (type in names(.self[["interactions"]])){
                              full.df <- tibble::tibble(regulator = NA, event = NA, nes = NA, .rows = 0)
                              for(mr in names(.self[["interactions"]][[type]])) {
                                df <- tibble::enframe(.self[["interactions"]][[type]][[mr]], 
                                              name = "event", value = "nes") %>%
                                  dplyr::mutate(regulator = mr)
                                full.df <- dplyr::bind_rows(full.df, df)
                              }
                              
                              write.table(full.df, file = paste0(output.folder, type,".", name, ".txt"),
                                          quote = FALSE, sep = "\t", row.names = FALSE)
                            }
                          }
                          
                          # save ranks as df
                          if(name == "ranks"){
                            df <- lapply(.self[["ranks"]], tibble::enframe) %>%
                              dplyr::bind_rows() %>% 
                              dplyr::mutate(type = rep(c("viper", "integrated"), each = length(.self[["ranks"]][[1]])))
                            
                            write.table(df, file = paste0(output.folder, name, ".txt"),
                                        quote = FALSE, sep = "\t", row.names = FALSE)
                          }
                          
                          # save hypotheses as df
                          if(name == "hypotheses"){
                            df <- lapply(.self[[name]], function(x){
                              tibble::tibble(type = NA, gene = x)
                            }) %>% dplyr::bind_rows()
                            event.nums <- vapply(.self[[name]], length, numeric(1))
                            df$type <- rep(names(event.nums), event.nums)
                            
                            write.table(df, file = paste0(output.folder, name, ".txt"),
                                        quote = FALSE, sep = "\t", row.names = FALSE)
                            
                          }
                          
                          # save checkpoints as df
                          if(name == "checkpoints"){
                            df <- lapply(.self[[name]], function(x){
                              tibble::tibble(cluster = NA, regulator = x)
                            }) %>% dplyr::bind_rows()
                            event.nums <- vapply(.self[[name]], length, numeric(1))
                            df$cluster <- rep(names(event.nums), event.nums)
                            
                            write.table(df, file = paste0(output.folder, name, ".txt"),
                                        quote = FALSE, sep = "\t", row.names = FALSE)
                            
                          }
                          
                          # save sample clustering as df
                          if(name == "sample.clustering"){
                            df <- tibble::enframe(.self[["sample.clustering"]], 
                                                  name = "sample", value = "cluster") 
                            
                            write.table(df, file = paste0(output.folder, name, ".txt"),
                                        quote = FALSE, sep = "\t", row.names = FALSE)
                          }
                          
                          # save coverage.summary stats as df
                          if(name == "coverage.summaryStats") {
                            df <- dplyr::bind_rows(.self[[name]]) %>%
                              dplyr::mutate(cluster = rep(seq_along(.self[[name]]), each = 100))
                            
                            write.table(df, file = paste0(output.folder, name, ".txt"),
                                        quote = FALSE, sep = "\t", row.names = FALSE)
                          }
                          
                          # save clustering results and genomic saturation as lists
                          if(name %in% c("clustering.results", "genomic.saturation")){
                            results <- .self[[name]]
                            save(results, 
                                 file = paste0(output.folder, name, ".rda"))
                          }
                          
                        }
                      }
                      
                    )
                    
)

utils::globalVariables(c("gene.map"))

#' MOMA Constructor Function
#' 
#' Create MOMA Object from either a MultiAssayExperiment object or a list of
#' assays.
#' See vignette for more information on how to set up and run the MOMA object
#' @param x A MultiAssayExerperiment object or list object with the following assays:
#' (note: by default assays must have these exact names. Otherwise they can be changed
#' using the viperAssay, mutMat, cnvMat and fusionMat parameters.)
#' \describe{
#' \item{viper}{VIPER protein activity matrix with samples as columns 
#' and rows as protein IDs}
#' \item{mut}{An indicator matrix (0/1) of mutation events with samples as 
#' columns and genes as rows}
#' \item{cnv}{A matrix of CNV scores (typically SNP6 array scores from TCGA) 
#' with samples as columns and genes as rows}
#' \item{fusion}{An indicator matrix (0/1) of fusion events with samples as 
#' columns and genes as rows} }
#' @param pathways A named list of lists. Each named list represents 
#' interactions between proteins (keys) and their associated partners
#' @param gene.loc.mapping A data.frame of band locations and Entrez IDs
#' @param output.folder Location to store output and intermediate results 
#' @param gene.blacklist A vector of genes to exclude from the analysis
#' @param viperAssay name associated with the viper assay in the assay object
#' @param mutMat name associated with the mutation matrix in the assay object
#' @param cnvMat name associated with the cnv matrix in the assay object
#' @param fusionMat name associated with the fusion matrix in the assay object
#' @importFrom utils data
#' @importFrom MultiAssayExperiment assays colData intersectColumns
#' @examples 
#' momaObj <- MomaConstructor(example.gbm.mae, gbm.pathways)
#' @return an instance of class Moma
#' @export
MomaConstructor <- function(x, pathways, gene.blacklist = NA_character_, 
                            output.folder = NA_character_, 
                            gene.loc.mapping = gene.map, viperAssay = "viper",
                            mutMat = "mut", cnvMat = "cnv", fusionMat = "fusion"){
  
  utils::data("gene.map")
  
  # check if x is MultiAssayExperiment or list object with the required assays
  if(is(x, "MultiAssayExperiment")){
    x <- checkMAE(x)
    type <- "mae"
  } else if (is.list(x)){
    x <- checkList(x)
    type <- "assaylist"
  } else {
    stop("Object supplied is not a MultiAssayExperiment or list object with assays.")
  }
  
  # check that genemap is exists/is valid if a different one is supplied
  checkGeneMap(gene.loc.mapping)
  
  # check pathway formatting and names
  checkPathways(pathways, x, type)
  
  ##### initialize new instance of class Moma ####
  if(type == "mae") {
    
    # first check for fusions
    if(fusionMat %in% names(assays(x))) {
      fusion <- assays(x)[[fusionMat]]
    } else {
      fusion <- matrix(NA)
    }
    
    obj <- Moma$new(viper = assays(x)[[viperAssay]], mut = assays(x)[[mutMat]], 
                    cnv = assays(x)[[cnvMat]], 
                    fusions = fusion, pathways = pathways, 
                    gene.blacklist = as.character(gene.blacklist), 
                    output.folder = output.folder, 
                    gene.loc.mapping = gene.loc.mapping)
  
    } else if (type == "assaylist") {
    
    # first check for fusions
    if(fusionMat %in% names(x)) {
      fusion <- x[[fusionMat]]
    } else {
      fusion <- matrix(NA)
    }
    
    obj <- Moma$new(viper = x[[viperAssay]], mut = x[[mutMat]], 
                    cnv = x[[cnvMat]], 
                    fusions = fusion, pathways = pathways, 
                    gene.blacklist = as.character(gene.blacklist), 
                    output.folder = output.folder, 
                    gene.loc.mapping = gene.loc.mapping)
  }
  
  obj
}



#' Check MultiAssayExperiment
#' 
#' @param mae MultiAssayExperiment object
#' @importFrom MultiAssayExperiment assays colData intersectColumns
#' @return updated/filtered MAE
#' @keywords internal
checkMAE <- function(mae){
  # confirm mae has viper, cnv, and mut assays (and optional fusion)
  if(length(intersect(names(assays(mae)) , c("viper", "mut", "cnv"))) == 3){
    message("Found the following assays:", paste(names(assays(mae)), collapse = ", "))
  } else {
    stop("Necessary assays not found. Please ensure names are 'viper', 'mut', 'cnv' (and 'fusion' if available) for the respective assays")
  }
  
  # confirm there are a sufficient number of samples
  if(nrow(colData(mae)) < 2) {
    stop("Not enough samples")
  }
  
  # print number of samples found in overlap
  message("Common samples across main assays: ", 
          suppressMessages(nrow(colData(suppressMessages(intersectColumns(mae[,,c("viper", "cnv", "mut")]))))))
  
  # filter mae to only return samples that are in the viper matrix
  vipersamples <- colnames(assays(mae)$viper)
  mae <- mae[ , vipersamples]
  mae
  
}

#' Check List of Assays
#' 
#' @param assaylist list of assays (viper, cnv, mut and fusion)
#' @return updated/filter assaylist obj
#' @keywords internal
checkList <- function(assaylist){
  if(length(intersect(names(assaylist) , c("viper", "mut", "cnv"))) == 3){
    message("Found the following assays:", paste(names(assaylist), collapse = ", "))
  } else {
    stop("Necessary assays not found. Please ensure names are 'viper', 'mut', 'cnv' (and 'fusion' if available) for the respective assays")
  }
  
  ### Confirm that a valid viper matrix has been supplied
  if (!is.matrix(assaylist$viper) || ncol(assaylist$viper) < 2 || nrow(assaylist$viper) < 2) {
    stop("Too few samples or TFs in viper matrix. Please supply valid matrix")
  }
  
  ### check for sample overlap 
  nVM <- intersect(colnames(assaylist$viper), colnames(assaylist$mut))
  assaylist$mut <- assaylist$mut[, nVM, drop = FALSE]
  message("Number of samples in VIPER + Mutation data: ", length(nVM))
  if (length(nVM) < 2) {
    stop("VIPER and mutation matrix samples don't match!")
  }
  nVM <- intersect(colnames(assaylist$viper), colnames(assaylist$cnv))
  assaylist$cnv <- assaylist$cnv[, nVM, drop = FALSE]
  message("Number of samples in VIPER + CNV data: ", length(nVM))
  if (length(nVM) < 2) {
    stop("VIPER and CNV matrix samples don't match!")
  }
  
  if ("fusion" %in% names(assaylist)) {
    nVM <- intersect(colnames(assaylist$viper), colnames(assaylist$fusion))
    # redo type conversion to matrix: could have a single row with this 
    # datatype so we must re-type it to guard against auto conversion to 'integer'
    assaylist$fusion <- as.matrix(assaylist$fusion[, nVM, drop = FALSE])
    message("Number of samples in VIPER + Fusion data: ", length(nVM))
    if (length(nVM) < 2) {
      stop("VIPER and Fusions matrix samples don't match!")
    }
  } 
  assaylist
  
}

#' Check Gene Map
#' 
#' @param gene.loc.mapping dataframe with gene names, entrez ids and cytoband locations
#' @return nothing
#' @keywords internal
checkGeneMap <- function(gene.loc.mapping){
  if (!is.null(gene.loc.mapping)) {
    # verify the column names
    if (!is(gene.loc.mapping, "data.frame")) {
      stop("Gene location mapping supplied is not a data.frame!")
    } else if (!("Entrez.IDs" %in% colnames(gene.loc.mapping))) {
      stop("Gene location mapping supplied does not have 'Entrez.IDs' attribute!")
    } else if (!("Cytoband" %in% colnames(gene.loc.mapping))) {
      stop("Gene location mapping supplied does not have 'Cytoband' attribute!")
    } else if (!("Gene.Symbol" %in% colnames(gene.loc.mapping))){
      stop("Gene location mapping supplied does not have 'Gene.Symbol' attribute!")
    }
  } else {
    stop("No gene - genomic location mapping provided!")
  }
}

#' Check Pathways
#' 
#' @param pathways A named list of lists. Each named list represents 
#' interactions between proteins (keys) and their associated partners
#' @param x the MAE or Assaylist 
#' @param type whether x is MAE or Assaylist
#' @return nothing
#' @keywords internal
checkPathways <- function(pathways, x, type){
  if(type == "mae") {
    viperTFs <- rownames(assays(x)$viper)
  } else if (type == "assaylist") {
    viperTFs <- rownames(x$viper)
  }
  
  ### Check overlap in viper protein names and pathways
  for (pathway in names(pathways)) {
    message("Checking labels on pathway ", pathway)
    I <- intersect(viperTFs, names(pathways[[pathway]]))
    if (length(I) == 0) {
      stop("No intersection with supplied pathway! Double check formatting")
    }
    message("Found labels for ", length(I), " TFs in VIPER matrix")
  }
}




#' Retain TCGA sample ids without the final letter designation ('A/B/C') 
#' 
#' @param input Matrix of expression or protein activity scores. Columns are 
#' sample names, rows are genes. Input can also just be an input vector of 
#' sample names.
#' @param desired.len length to reduce strings to. Default is 15 because of 
#' TCGA naming conventions
#' @examples 
#' sample.names <- c("TCGA-14-1825-01A", "TCGA-76-4931-01B", "TCGA-06-5418-01A")
#' sampleNameFilter(sample.names)
#' @return An identical matrix with new (shorter) column names, 
#' or a vector with the shortened names. 
#' @export
sampleNameFilter <- function(input, desired.len = 15) {
  # filter down to sample Id without the 'A/B/C sample class'.
  if(is.matrix(input)) {
    sample.ids <- vapply(colnames(input), function(x) substr(x, 1, desired.len), 
                         FUN.VALUE = character(1))
    colnames(input) <- sample.ids
  } else if (is.vector(input)) {
    input <- substr(input, 1, desired.len)
  }
  
  input
}

#' Glioblastoma (GBM) Example Dataset
#' 
#' MultiAssayExperiment Object containing all the genomic assays needed to run
#' the example code for MOMA
#' 
#' @format An MultiAssayExperiment object with 4 different sets of GBM assays
#' \describe{
#' \item{viper}{matrix of viper scores with samples in columns and regulators
#'  across the rows}
#' \item{mut}{matrix of samples and genes with potential mutations.
#' 0 for no mutation, 1 for presence of some non-silent mutation}
#' \item{cnv}{matrix of samples and genes with copy number variant scores}
#' }
"example.gbm.mae"


#' Glioblastoma (GBM) Pathways
#' 
#' Object containing information about the biological pathways that will be used
#' in the analysis
#' 
#' @format A list of lists named "cindy" and "preppi" respectively
#' \describe{
#' \item{cindy}{list of regulators, each with a set of modulators and p values
#' representing their CINDY inferred association}
#' \item{preppi}{list of regulators, each with a set of potential binding
#' partners and PREPPi inferred p values for probability of binding}
#' }
"gbm.pathways"

#' MutSig Blacklisted genes
#' 
#' List of genes to not include in the DIGGIT mutation inference because they 
#' have been found to be mutated more often than expected by chance given 
#' background mutation processes.
#' 
#' @format A character vector of Entrez Gene IDs 
#' @source \url{https://software.broadinstitute.org/cancer/cga/mutsig}
"mutSig"

#' Gene Location Mapping
#' 
#' Table used for converting between different forms of gene information.
#' Downloaded from HGNC's custom download portal using the "Approved Symbol", 
#' "NCBI Gene ID", "Chromosome" and "Ensembl Gene ID" curated data options 
#' and only those with "Approved" status.
#' Updated December 2019.
#' 
#' @format A Data frame with 4 columns
#' \describe{
#' \item{Gene.Symbol}{Approved Symbol gene name}
#' \item{Entrez.IDs}{NCBI Gene ID}
#' \item{Cytoband}{Chromosome location}
#' \item{Ensembl}{Ensembl gene ID}
#' }
#'  @source \url{https://www.genenames.org/download/custom/}
"gene.map" 

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup, message = FALSE, results="hide", warning=FALSE, eval=FALSE--------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# BiocManager::install("MOMA")

## ----load---------------------------------------------------------------------
library(MOMA)

## ----explore data, message = FALSE--------------------------------------------
example.gbm.mae

MultiAssayExperiment::assays(example.gbm.mae)$viper[1:3, 1:3]

## ----pathways-----------------------------------------------------------------
names(gbm.pathways)

gbm.pathways$cindy[1:3]

## ----moma object--------------------------------------------------------------
momaObj <- MomaConstructor(example.gbm.mae, gbm.pathways)

## ----interactions, results = "hide", message = FALSE--------------------------
momaObj$runDIGGIT()

momaObj$makeInteractions()

momaObj$Rank()

## ----clustering---------------------------------------------------------------
momaObj$Cluster()

# Explore the reliability scores
momaObj$clustering.results$all.cluster.reliability

# Save in the 3 cluster solution
momaObj$sample.clustering <- momaObj$clustering.results$`3clusters`$clustering


## ----saturation, message=FALSE, results="hide"--------------------------------
momaObj$saturationCalculation()

## ----checkpoints--------------------------------------------------------------
cluster1.checkpoint <- momaObj$checkpoints[[1]]
print (cluster1.checkpoint[1:5])

## ----make plots, warning=FALSE, include=FALSE---------------------------------
plots <- makeSaturationPlots(momaObj)

## ----visualize plots----------------------------------------------------------
library(ggplot2)
library(grid)
grid.draw(plots$oncoprint.plots[[3]])
plots$curve.plots[[3]] +
  ggtitle("Genomic Saturation Curve for GBM Subtype 3")
  

## ----saving data, eval=FALSE--------------------------------------------------
# momaObj$saveData(output.folder = "outputs", "hypotheses", "checkpoints")

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#' Get coverage of interactions
#' 
#' @param MomaObject A numeric vector with cluster membership, names are samples
#' @param viper.samples Calculate the genomic coverage only for these sample
#' @param cMR.ranking A vector entrez IDs, in order
#' @param topN Compute coverage for only the top -N- Master Regulators
#' @param mutation.filter Retain only mutation events in this (positive) list
#' @return A list of lists, indexed by sample name, with coverage statistics
#' for each sample
#' @keywords internal
getCoverage <- function(MomaObject, cMR.ranking, viper.samples, topN = 100, 
                        mutation.filter = NULL, verbose = FALSE) {
    
    if (!is(MomaObject, "Moma")) {
        stop("Must have instantiated Moma class object passed!")
    }
    
    # select considered cMRs
    selected.tfs <- cMR.ranking[seq_len(topN)]
    if (length(selected.tfs) == 0) {
        stop("No TFs selected!")
    }
    
    # confirm they are in Entrez ID format
    
    is.entrezIDs <- function(vec) {
        all(vapply(seq_along(vec), function(i) as.numeric(vec)[i]==vec[i], FUN.VALUE = logical(1)))
    }
    if (isFALSE(is.entrezIDs(selected.tfs))) {
        stop("TFs not in entrez ID format!")
    }
    
    # For each event type, gets names of cMRs that have those events
    interaction.map <- validDiggitInteractions(MomaObject$interactions, 
                                               MomaObject$gene.loc.mapping, 
                                               selected.tfs)
    
    # another assert statment: make sure we have non-zero interactions for each
    for (key in names(interaction.map)) {
        if (sum(vapply(interaction.map[[key]], length, FUN.VALUE = numeric(1))) < 1) {
            warning("Didn't find any positive DIGGIT associations for data type ",
                    key, " in subtype")
        }
    }
    
    oc <- sampleOverlap(MomaObject, viper.samples, selected.tfs, interaction.map, 
                        mutation.filter = mutation.filter, verbose = verbose)
    # count mutations/amps/dels covered at this point. Aggregate stats
    
    oc
}


#' Return a set of events 'covered' by specified cMR-event interactions 
#' @param interactions List indexed by amp/mut/del/fus from cMRs to interacting 
#' events
#' @param gene.loc.mapping Data.frame mapping entrezIDs to cytoband locations
#' @param selected.tfs For each event type list, search within only these cMRS
#' @return a list of events 'covered' by the supplied interactions of 
#' type mut/amp/del/fus
#' @keywords internal
validDiggitInteractions <- function(interactions, gene.loc.mapping, 
                                    selected.tfs) {
    
    if (length(selected.tfs) == 0) {
        stop("No TFs input to diggit function")
    }
    selected.tfs <- as.character(selected.tfs)
    
    mut.tfs <- selected.tfs[which(selected.tfs %in% names(interactions[["mut"]]))]
    amp.tfs <- selected.tfs[which(selected.tfs %in% names(interactions[["amp"]]))]
    del.tfs <- selected.tfs[which(selected.tfs %in% names(interactions[["del"]]))]
    fus.tfs <- selected.tfs[which(selected.tfs %in% names(interactions[["fus"]]))]
    
    if (length(mut.tfs) == 0 || length(amp.tfs) == 0 || length(del.tfs) == 0) {
        stop("No valid TFs in the interactions supplied!")
    } else if (length(fus.tfs) == 0) {
        message("No valid fusion interactions...")
    }
    
    mut.I <- subsetListInteractions(interactions[["mut"]], mut.tfs)
    del.I <- subsetListInteractions(interactions[["del"]], del.tfs)
    amp.I <- subsetListInteractions(interactions[["amp"]], amp.tfs)
    
    # only subset if fusions exist fusions IDs are unique , nothing else necessary
    if (length(fus.tfs) >= 1) {
        fus.I <- subsetListInteractions(interactions[["fus"]], fus.tfs)
        covered.fusions <- fus.I
    }
    
    
    # Add cnv events to mutation coverage, as either copy number variation is 
    # valid evidence for explaining a patient's mutation
    covered.mutations <- mergeLists(mut.I, del.I)
    covered.mutations <- mergeLists(covered.mutations, amp.I)
    
    # Add mut events to cnv coverage, as it is a valid type of evidence for 
    # explaining a patient's CNV change
    covered.amps <- mergeLists(amp.I, mut.I)
    covered.dels <- mergeLists(del.I, mut.I)
    
    
    
    # create a new mapping from TF in Entrez -> event location
    covered.amps.LOC <- lapply(names(covered.amps), function(x, I) {
        geneNames <- I[[as.character(x)]]
        band.names <- unique(as.character(gene.loc.mapping[which(gene.loc.mapping$Entrez.IDs %in% geneNames), "Cytoband"]))
        if (length(band.names) == 0 & length(geneNames) == 0) {
            #print(paste("No amplification events associated with", as.character(x)))
            band.names <- NA 
        } else if (length(band.names) == 0) {
            warning(paste("Could not map entrez IDs to Cytoband for IDS,
                          skipping...", geneNames))
            band.names <- NA
        }
        band.names
    }, I = covered.amps)
    names(covered.amps.LOC) <- names(covered.amps)
    covered.amps.LOC <- covered.amps.LOC[!is.na(covered.amps.LOC)]
    
    if (sum(vapply(covered.amps.LOC, length, FUN.VALUE = numeric(1))) == 0) {
        stop("Something went wrong when mapping amplification Entrez.IDs
              to Cytoband IDs. Quitting...")
    }
    
    # create a new mapping from TF in Entrez -> event location
    covered.dels.LOC <- lapply(names(covered.dels), function(x, I) {
        geneNames <- I[[as.character(x)]]
        band.names <- unique(as.character(gene.loc.mapping[which(gene.loc.mapping$Entrez.IDs %in% geneNames), "Cytoband"]))
        if (length(band.names) == 0 & length(geneNames) == 0) {
            #print(paste("No deletion events associated with", as.character(x)))
            band.names <- NA 
        } else if (length(band.names) == 0) {
            warning("Could not map entrez IDs to Cytoband for IDS,
                          skipping... ", geneNames)
            band.names <- NA
        }
        band.names
    }, I = covered.dels)
    names(covered.dels.LOC) <- names(covered.dels)
    covered.dels.LOC <- covered.dels.LOC[!is.na(covered.dels.LOC)]
    
    if (sum(vapply(covered.dels.LOC, length, FUN.VALUE = numeric(1))) == 0) {
        stop("Something went wrong when mapping deletion Entrez.IDs
              to Cytoband IDs. Quitting...")
    }
    
    # don't incorporate fusions into final list object unless they exist
    if (length(fus.tfs) >= 1) {
        return(list(mut = covered.mutations, amp = covered.amps.LOC, 
                    del = covered.dels.LOC, fus = covered.fusions))
    } else {
        return(list(mut = covered.mutations, amp = covered.amps.LOC, 
                    del = covered.dels.LOC))
    }
}


#' The core function to compute which sample-specific alterations overlap with 
#' genomic events that are explained 
#' via DIGGIT. 
#' @importFrom utils head
#' @param MomaObject Object reference of momaRunner class
#' @param viper.samples Sample vector to restrict sample-specific analysis to
#' @param selected.tfs Transcription factors being analyzed
#' @param interaction.map List object of events 'covered' by the supplied 
#' interactions of type mut/amp/del/fus
#' @param cnv.threshold Numeric absolute value to threshold SNP6 and/or GISTIC 
#' or other CNV scores. Above that absolute value is considered a positive event. 
#' @param mutation.filter A vector of whitelisted mutation events, in entrez gene IDs
#' @param idx.range Number of tfs to check for genomic saturation calculation, 
#' default is 1253
#' @param verbose Output status during the run (default=FALSE)
#' @return A list of lists, indexed by sample name, with coverage 
#' statistics/data for each sample
#' @keywords internal
sampleOverlap <- function(MomaObject, viper.samples, selected.tfs, interaction.map,
                          cnv.threshold = 0.5, mutation.filter = NULL, 
                          idx.range = NULL, verbose = FALSE) {
    
    if (is.null(MomaObject$hypotheses)) {
        stop("No hypothesis set for momaRunner class object!!")
    }
    
    map <- MomaObject$gene.loc.mapping
    
    mut.HYP.filter <- MomaObject$hypotheses[["mut"]]
    amp.HYP.filter <- na.omit(unique(vapply(as.character(MomaObject$hypotheses[["amp"]]), function(x) {
        res <- NA
        x <- as.character(x)
        if (x %in% map$Entrez.IDs) {
            # get cytoband location for this gene if it's in the map
            res <- unique(map[which(map$Entrez.IDs == x), "Cytoband"])
        }
        as.character(res)
    }, FUN.VALUE = character(1))))
    del.HYP.filter <- na.omit(unique(vapply(as.character(MomaObject$hypotheses[["del"]]), function(x) {
        res <- NA
        x <- as.character(x)
        if (x %in% map$Entrez.IDs) {
            # get cytoband location for this gene if it's in the map
            res <- unique(map[which(map$Entrez.IDs == x), "Cytoband"])
        }
        as.character(res)
    }, FUN.VALUE = character(1))))
    fus.HYP.filter <- MomaObject$hypotheses[["fus"]]
    
    if (length(mut.HYP.filter) == 0) {
        stop("No hypotheses for mut!")
    } else if (length(amp.HYP.filter) == 0) {
        stop("No hypotheses for amp!")
    } else if (length(del.HYP.filter) == 0) {
        stop("No hypotheses for del!")
    } else if (length(fus.HYP.filter) == 0) {
        #message("Zero fusion hypotheses")
    }
    # consider only samples triple intersection of samples with CNV, mutation and RNA (i.e. VIPER inferences) data
    all.samples.genomics <- intersect(colnames(MomaObject$mut), colnames(MomaObject$cnv))
    all.sample.names <- intersect(all.samples.genomics, viper.samples)
    coverage <- lapply(all.sample.names, function(sample) {
        
        if(verbose){
            message("Computing coverage for sample ", sample)
        }
        
        
        # find active and inactive proteins in this sample
        viper.pvals <- (1 - pnorm(abs(MomaObject$viper[, sample])))
        active.proteins <- rownames(MomaObject$viper)[intersect(which(viper.pvals < 0.05), which(MomaObject$viper[, sample] > 0))]
        if (length(active.proteins) == 0) {
            warning("No active proteins found for sample: ", sample)
        }
        
        # Collect mutation events in this sample's row:
        mut.events <- as.character(names(which(MomaObject$mut[, sample] > 0)))
        mut.events <- intersect(mut.events, MomaObject$hypotheses[["mut"]])
        
        # entrez ids to cytoband get genes
        del.events <- as.character(names(which(MomaObject$cnv[, sample] < -cnv.threshold)))
        del.events.entrez <- intersect(del.events, MomaObject$hypotheses[["del"]])
        # map to genomic locations
        del.events.cytoband <- unique(map[which(map$Entrez.IDs %in% del.events.entrez), "Cytoband"])
        
        # get genes
        amp.events <- as.character(names(which(MomaObject$cnv[, sample] > cnv.threshold)))
        amp.events.entrez <- intersect(amp.events, MomaObject$hypotheses[["amp"]])
        # map to genomic locations
        amp.events.cytoband <- unique(map[which(map$Entrez.IDs %in% amp.events.entrez), "Cytoband"])
        
        # not all samples will have fusions: include if possible
        fus.events <- NULL
        if (!is.null(fus.HYP.filter)) {
            if (sample %in% colnames(MomaObject$fusions)) {
                fus.events <- names(which(MomaObject$fusions[, sample] > 0))
                if(length(fus.events) == 0) {
                    fus.events <- NULL
                } 
            } 
        }
        fus.events <- fus.events[which(fus.events %in% MomaObject$hypotheses[["fus"]])]
        
        validated.del.locations <- del.events.cytoband
        validated.amp.locations <- amp.events.cytoband
        validated.fusion.events <- fus.events
        validated.mut.events <- mut.events
        
        if (!is.null(mutation.filter)) {
            message("Using mutation filter:")
            prev.count <- length(validated.mut.events)
            validated.mut.events <- intersect(mutation.filter, validated.mut.events)
            removed = prev.count - length(validated.mut.events)
            message("Filtered out: ", removed, " mutations using filter...")
        }
        
        
        if (verbose) {
            message("MUTS:", length(validated.mut.events))
            message("DELS:", length(validated.del.locations))
            message("AMPS:", length(validated.amp.locations))
            message("FUS:", length(validated.fusion.events))
            message(" ")
        }
        
        
        
        # for each K in 1:N, compute the coverage of the top K events and return the stats
        sample.cover <- lapply(seq_along(selected.tfs), function(x) c())
        # do a semi-complete range for speed and if supplied already with a range, then use that
        if (is.null(idx.range)) {
            if (length(selected.tfs) > 100) {
                idx.range <- seq_len(50)
                idx.range <- c(idx.range, 26:50 * 2)
                idx.range <- c(idx.range, 11:30 * 10)
                idx.range <- c(idx.range, 13:25 * 25)
                idx.range <- c(idx.range, 7:12 * 100)
                idx.range <- c(idx.range, 1253)
            } else {
                idx.range = seq_along(selected.tfs)
            }
        }
        
        # store the set of active MRs, if it's identical to the last iteration, update and skip re-computation
        active.mrs.length.LAST <- 0
        last.idx <- 1
        for (i in idx.range) {
            # use these for coverage
            top.N.tfs <- selected.tfs[seq_len(i)]
            active.mrs <- intersect(active.proteins, top.N.tfs)
            
            # if no extra active mrs this round, copy previous stats and continue
            if ((length(active.mrs) == active.mrs.length.LAST) & (i > 1)) {
                sample.cover[[i]] <- sample.cover[[last.idx]]
                next
            } else {
                active.mrs.length.LAST <- length(active.mrs)
                last.idx <- i
            }
            
            # print ('Active MRs:') print (active.mrs)
            covered.mut <- unique(unlist(lapply(active.mrs, function(mr) {
                covered <- intersect(interaction.map$mut[[mr]], validated.mut.events)
                covered
            })))
            covered.del <- unique(unlist(lapply(active.mrs, function(mr) {
                covered <- intersect(interaction.map$del[[mr]], validated.del.locations)
                covered
            })))
            covered.amp <- unique(unlist(lapply(active.mrs, function(mr) {
                covered <- intersect(interaction.map$amp[[mr]], validated.amp.locations)
                covered
            })))
            covered.fus <- unique(unlist(lapply(active.mrs, function(mr) {
                covered <- intersect(interaction.map$fus[[mr]], validated.fusion.events)
                covered
            })))
            amp.frac <- ifelse(length(validated.amp.locations) == 0, NA, length(covered.amp)/length(validated.amp.locations))
            del.frac <- ifelse(length(validated.del.locations) == 0, NA, length(covered.del)/length(validated.del.locations))
            mut.frac <- ifelse(length(validated.mut.events) == 0, NA, length(covered.mut)/length(validated.mut.events))
            fus.frac <- ifelse(length(validated.fusion.events) == 0, NA, length(covered.fus)/length(validated.fusion.events))
            
            # compute total frac
            total.frac <- NA
            total.num.events <- length(c(validated.mut.events, validated.amp.locations, validated.del.locations, validated.fusion.events))
            
            total.frac <- ifelse(length(total.num.events) == 0, NA, (length(covered.amp) + length(covered.del) + length(covered.mut) + length(covered.fus))/total.num.events)
            sample.cover[[i]] <- list(amp = covered.amp, del = covered.del, mut = covered.mut, fus = covered.fus, amp.frac = amp.frac, del.frac = del.frac, 
                                      mut.frac = mut.frac, fus.frac = fus.frac, total.frac = total.frac)
        }
        sample.cover
    })
    names(coverage) <- all.sample.names
    coverage
}


#' @title Helper function: subset a list to the set of keys supplied return the 
#' names of interactions with positive values, in a list structure
#' @param int.l List of interactions, at each index this is a numeric named vector
#' @param keys Keys used to reduce interactions
#' @return Returns a filtered list of interactions in the same format as the input
#' @keywords internal
subsetListInteractions <- function(int.l, keys) {
    
    filtered.I <- lapply(keys, function(key, interactions) {
        I <- interactions[[as.character(key)]]
        # named vector
        event.names <- names(I[which(I > 0)])
        event.names
    }, interactions = int.l)
    names(filtered.I) <- keys
    
    filtered.I
}

#' Helper function
#' @param l1 list 1
#' @param l2 list 2
#' @return single merged list
#' @keywords internal
mergeLists <- function(l1, l2) {
    
    merged <- list()
    inter <- intersect(names(l1), names(l2))
    # combine joint entries
    for (key in inter) {
        merged[[key]] <- union(l1[[key]], l2[[key]])
    }
    # add entries unique to l1
    for (key in setdiff(names(l1), names(l2))) {
        merged[[key]] <- l1[[key]]
    }
    # add entries unique to l2
    for (key in setdiff(names(l2), names(l1))) {
        merged[[key]] <- l2[[key]]
    }
    return(merged)
}


#' @title mergeGenomicSaturation Create data frame from coverage data, including
#'  number of total events 'covered' and unique events
#' @param coverage.range List indexed by sample, then sub-indexed by # of master
#'  regulators, then by event type (mut/amp/del/fus). Holds all events by sample
#' @param topN Maximum number of master regulators to compute coverage
#' @return A data frame with summary statistics for genomic saturation at each k
#' @keywords internal
mergeGenomicSaturation <- function(coverage.range, topN) {
    
    data <- c()
    for (i in seq_len(topN)) {
        # count for each sample $mut/amp/del all point to either a NA or a vector of names of the event. If NA the length will be zero so simply count the
        # number of each type of event
        count <- unlist(lapply(coverage.range, function(x) {
            num.events <- length(x[[i]]$mut) + length(x[[i]]$amp) + length(x[[i]]$del)
        }))
        count <- na.omit(count)
        
        # apply over each sample, get the coverage for each
        fraction <- unlist(lapply(coverage.range, function(x) {
            # critically: must omit the NAs so they don't interfere with count
            event.fractions <- x[[i]]$total.frac
            event.fractions
        }))
        fraction <- na.omit(fraction)
        
        all.events <- unlist(lapply(coverage.range, function(x) {
            c(x[[i]]$mut, x[[i]]$amp, x[[i]]$del)
        }))
        all.events <- na.omit(all.events)
        
        data <- rbind(data, c(i, mean(count), mean(fraction), length(unique(all.events))))
    }
    df <- data.frame(mean = data[, 2], k = data[, 1], fraction = data[, 3], unique.events = data[, 4])
    df
}


#' @title Fit based on fractional overall coverage of genomic events
#' @param sweep Numeric vector of genomic coverage values, named by -k- threshold 
#' @param frac Fraction of coverage to use as a threshold (default .85 = 85 percent)
#' @return The -k- integer where coverage is acheived
#' @keywords internal
fitCurvePercent <- function(sweep, frac = 0.85) {
    fractional <- as.numeric(as.character(sweep))/max(sweep)
    best.k <- names(sweep[which(fractional >= frac)])[1]
    return(as.numeric(best.k))
}

---
title: "MOMA - Multi Omic Master Regulator Analysis"
author: "Sunny Jones, Evan Paull, Mariano Alvarez, Federico Giorgi and Andrea Califano"
output: BiocStyle::html_document
#bibliography: bibliography.bib
vignette: >
  %\VignetteIndexEntry{MOMA - Multi Omic Master Regulator Analysis}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Introduction and Background

MOMA is a tool for inferring connections between Master Regulator proteins and 
genomic driver events in cancer. Master regulators are regulatory proteins 
(primarily transcription factors and co-transcription factors) that control cell
state. In the case of cancer and other disease states transcription factors have 
been shown to be key drivers of maintaining the disease state and can be targets 
for interventions. Often these master regulators are not mutated themselves but 
are downstream of mutations and other genomic alterations that ultimately 
dysregulate the normal activity of that regulator. MOMA uses multiple inputs of 
information to infer these connections and to improve the predictive value of 
the master regulator analysis.  



*For more information on Master Regulators and our tool for calculating their values see the paper published on VIPER in Nature Genetics in 2016* 
[paper](https://www.nature.com/articles/ng.3593) // [package](https://bioconductor.org/packages/release/bioc/html/viper.html).

*** 

# Running MOMA

## Getting Started

First install and load the library into the R session. Make sure all the other 
dependent packages have already been installed to ensure full functionality, 
including graphics and plotting functions.  


```{r setup, message = FALSE, results="hide", warning=FALSE, eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("MOMA")
```


```{r load}
library(MOMA)
```


Explore the test data saved in the `MultiAssayExperiment` object. Confirm that we 
have 50 test samples and 2505 VIPER inferred proteins in the test viper matrix. 
This was generated by using `VIPER` on the GBM gene expression signature. The 
matrix has the samples across the columns and the regulators in the rows.  

The other assays needed for the experiment are:

- **SNP matrix**: binary 0/1 values where 1 indicates the prescence of a mutation
- **CNV matrix**: copy number variant values
- **Fusion matrix**: binary 0/1 values (optional)



```{r explore data, message = FALSE}
example.gbm.mae

MultiAssayExperiment::assays(example.gbm.mae)$viper[1:3, 1:3]
```

Next, we select the biological pathways we'd like to use to aid in our inference 
task. In this case, we're using the CINDy modulator inference algorithm [[paper](https://journals.plos.org/plosone/article?id=10.1371/journal.pone.0109569)] 
as well as protein-protein interactions predicted by the PrePPI structure-based 
algorithm [[paper](https://academic.oup.com/nar/article/41/D1/D828/1070064)]. 
The output of the CINDy algorithm is a likelihood (p value) for
the association of an upstream modulator with a particular regulators activity.
The relevant output for PrePPI is a likelihood (p value) that a modulator 
structurally binds to a regulator.

To make the MOMA object they need to be a named list of lists, with the indexes
of each being a regulator and their associated partners.

*note: CINDy values are context specific and need to be obtained for a particular 
tissue/expression set. Values calculated from the tumor types in TCGA can be found
[[here](https://figshare.com/articles/CINDy_Networks_from_TCGA/12198510)] for use in applying this analysis to other datasets. The PREPPi values are not context specific
and the values from this example analysis can be used with other datasets.* 

```{r pathways}
names(gbm.pathways)

gbm.pathways$cindy[1:3]
```

## Generating the **MOMA** object

Initialize the Moma object with the assays and pathway data in order to start
the analysis. The required inputs are the following:

- **Assays**: a MultiAssayExperiment object with the previously mentioned assays.
Alternatively a named list with the assays as matrices can be supplied. In both 
cased the names of the assays must be "viper", "cnv", "mut" and "fusion"
- **Pathway list**: see above

Other optional inputs include:

- **Gene Blacklist**: genes to not include in the analysis. By default the Broad
Institute's list of highly mutated genes are excluded [[link](https://software.broadinstitute.org/cancer/cga/mutsig)]
- **Output Folder** : Directory to save results to.
- **Gene Map** : Dataframe mapping Gene Names to Entrez IDs and Cytoband locations.
One is already provided by default. 

```{r moma object}
momaObj <- MomaConstructor(example.gbm.mae, gbm.pathways)
```

## MOMA Analysis on GBM Data

The first step, `runDIGGIT()`  will run the DIGGIT inference algorithm [[paper](https://www.cell.com/cell/fulltext/S0092-8674(14)01170-2)] to
find statistical interactions between VIPER-inferred proteins and genomic events.  

The `makeInteractions()` function will infer robust computational predictions
using all the provided data, including the Conditional Inference of Network Dynamics 
(CINDy) algorithm.  

The `Rank()` function will create a final ranking of candidate Master Regulators
for this cohort of patient samples.

```{r interactions, results = "hide", message = FALSE}
momaObj$runDIGGIT()

momaObj$makeInteractions()

momaObj$Rank()
```

Clustering of the samples, using the protein ranks computed in the last step, 
can then be performed using `Cluster()`. Multiple cluster solutions will be 
calculated, ranging from 2 to 15 clusters by default. The reliability or 
average silhouette scores of each can be assessed to determine an optimal 'k' 
number of clusters. By default the clustering solution with the maximum 
reliability will be saved to the object, but any solution can be saved in afterwards.

```{r clustering}
momaObj$Cluster()

# Explore the reliability scores
momaObj$clustering.results$all.cluster.reliability

# Save in the 3 cluster solution
momaObj$sample.clustering <- momaObj$clustering.results$`3clusters`$clustering

```

  
Genomic saturation analysis is then performed on each cluster with the 
`saturationCalculation()` function, allowing us to find the key proteins that are 
downstream of the majority of genomic events in the samples within a particular 
cluster. These regulators make up that cluster's `checkpoint`.  

The results of this analysis can be accessed directly in the following result 
fields:  
  
  - `momaObj$checkpoints` 
  - `momaObj$genomic.saturation`
  - `momaObj$coverage.summaryStats` 
  
These will be used for plotting the genomic saturation curves as well.
  
```{r saturation, message=FALSE, results="hide"}
momaObj$saturationCalculation()
```

```{r checkpoints}
cluster1.checkpoint <- momaObj$checkpoints[[1]]
print (cluster1.checkpoint[1:5])
```

***

# Plotting the Results

## Visualizing the VIPER matrix  

The primary results of the analysis are the master regululators of each particular
cluster's checkpoint, as displayed above. You can plot the original VIPER matrix 
subset down to only these regulators using whatever heatmap function you like. 


## Visualizing the Genomic Saturation and Events Plots

The other important results of the analysis are the statisically significant
genomic events found to be upstream of each of the checkpoint master regulators. 
The `makeSaturationPlots()` function takes the subtype specific genomic event 
interactions calculated in the previous step and makes plots for viewing the 
results. Because there are usually quite a large number of events that are 
detected only the most frequently occurring events will be plotted. 
(Note: to account for amplifications and deletions being events that can occur
across multiple genes, these events are considered on a cytoband basis).

```{r make plots, warning=FALSE, include=FALSE}
plots <- makeSaturationPlots(momaObj)
```


The two plot types are: 

- **Genomic Event Oncoprint Plots** : these plot the different types of 
genomic events found to be upstream of the regulators in the checkpoint,
using the style of cBioPortal's plotting. The samples in that cluster are in
the columns and the rows are the top significant events to be plotted (max
number can be changed). Summary bar plots are on the top and right side.
- **Saturation Curves** : these plot the number of regulators needed to capture
a certain percentage of genomic events. The inflection points plotted on
this graph match up with the cut off for which regulators make up a particular
cluster's checkpoint.   

The data for these plots are stored as grobs and ggplot objects so layers or other 
graphic modifications can be added afterwards for further customization.

```{r visualize plots}
library(ggplot2)
library(grid)
grid.draw(plots$oncoprint.plots[[3]])
plots$curve.plots[[3]] +
  ggtitle("Genomic Saturation Curve for GBM Subtype 3")
  
```

# Saving Data

Any of the results fields can be saved by using the `saveData()` function. 
Pass in any of the names of the results fields and they will be saved to files
in the designated output folder. If no names are passed all results will be saved.

```{r saving data, eval=FALSE}
momaObj$saveData(output.folder = "outputs", "hypotheses", "checkpoints")
```


# Session Info 

Here is the output of sessionInfo() on the system on which this package and
documentation was compiled.

```{r sessionInfo}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/moma.r
\docType{class}
\name{Moma-class}
\alias{Moma-class}
\alias{Moma}
\title{MOMA Object}
\description{
Main class encapsulating the input data and logic of the MOMA algorithm
}
\section{Fields}{

\describe{
\item{\code{viper}}{matrix of inferred activity score inferred by viper}

\item{\code{mut}}{binary mutation matrix 1 for presence of mutation, 0 for not, NA 
if not determined}

\item{\code{cnv}}{matrix of cnv values. Can be binary or a range.}

\item{\code{fusions}}{binary matrix of fusion events if appliable}

\item{\code{pathways}}{list of pathways/connections to consider as extra evidence 
in the analysis}

\item{\code{gene.blacklist}}{character vector of genes to not include because of 
high mutation frequency}

\item{\code{output.folder}}{character vector of location to save files if desired}

\item{\code{gene.loc.mapping}}{data frame of gene names, entrez ids and cytoband locations}

\item{\code{nes}}{field for saving Normalized Enrichment Matrices from the associate events step}

\item{\code{interactions}}{field for saving the MR-interactions list}

\item{\code{clustering.results}}{results from clustering are saved here}

\item{\code{ranks}}{results field for ranking of MRs based on event association analysis}

\item{\code{hypotheses}}{results field for saving events that have enough occurences to be considered}

\item{\code{genomic.saturation}}{results field for genomic saturation analysis}

\item{\code{coverage.summaryStats}}{results field for genomic saturation analysis}

\item{\code{checkpoints}}{results field with the MRs determined to be the checkpoint for each cluster}

\item{\code{sample.clustering}}{field to save sample clustering vector. Numbers are 
cluster assignments, names are sample ids}
}}

\section{Methods}{

\describe{
\item{\code{Cluster(
  clus.eval = c("reliability", "silhouette"),
  use.parallel = FALSE,
  cores = 1
)}}{Cluster the samples after applying the MOMA weights to the VIPER scores}

\item{\code{makeInteractions(
  genomic.event.types = c("amp", "del", "mut", "fus"),
  cindy.only = FALSE
)}}{Make interaction web for significant MRs based on their associated events}

\item{\code{Rank(
  use.cindy = TRUE,
  genomic.event.types = c("amp", "del", "mut", "fus"),
  use.parallel = FALSE,
  cores = 1
)}}{Rank MRs based on DIGGIT scores and number of associated events}

\item{\code{runDIGGIT(fCNV = NULL, cnvthr = 0.5, min.events = 4, verbose = FALSE)}}{Run DIGGIT association function to get associations for driver genomic events}

\item{\code{saturationCalculation(
  clustering.solution = NULL,
  cov.fraction = 0.85,
  topN = 100,
  verbose = FALSE
)}}{Calculate the number of MRs it takes to represent the desired coverage fraction of events}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.interactions.r
\name{getPvalsMatrix}
\alias{getPvalsMatrix}
\title{Utility function}
\usage{
getPvalsMatrix(corrected.scores)
}
\arguments{
\item{corrected.scores}{- corrected p-values processed by 'qvals' package}
}
\value{
A matrix of p-values for scores between genes/events (rows) and 
TFs (columns)
}
\description{
Utility function
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genomic.saturation.r
\name{validDiggitInteractions}
\alias{validDiggitInteractions}
\title{Return a set of events 'covered' by specified cMR-event interactions}
\usage{
validDiggitInteractions(interactions, gene.loc.mapping, selected.tfs)
}
\arguments{
\item{interactions}{List indexed by amp/mut/del/fus from cMRs to interacting 
events}

\item{gene.loc.mapping}{Data.frame mapping entrezIDs to cytoband locations}

\item{selected.tfs}{For each event type list, search within only these cMRS}
}
\value{
a list of events 'covered' by the supplied interactions of 
type mut/amp/del/fus
}
\description{
Return a set of events 'covered' by specified cMR-event interactions
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rank.r
\name{cnvScoreStouffer}
\alias{cnvScoreStouffer}
\title{Integrate CNV scores}
\usage{
cnvScoreStouffer(
  mapping,
  diggit.interactions,
  cytoband = TRUE,
  from.p = FALSE,
  pos.nes.only = TRUE
)
}
\arguments{
\item{mapping}{a named vector of genomic locations/cytoband IDs. 
names are the gene names for each--i.e. a many to one mapping from HUGO or entrez IDs to cytoband location}

\item{diggit.interactions}{list indexed by MR/TF name in Entrez Space each points to a named vector of NES / z-scores associated with entrez IDs for each interacting event.}

\item{cytoband}{Boolean to use cytoband locations for computing final integrated score}

\item{from.p}{Boolean, set TRUE if diggit.interaction values are p-values instead of z-scores}

\item{pos.nes.only}{Boolean, only consider positive DIGGIT association scores when ranking candidate MRs (default=TRUE)}
}
\value{
A vector of z-scores, named by the Master Regulators in 'diggit.interactions'
}
\description{
Integrate CNV scores
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{mutSig}
\alias{mutSig}
\title{MutSig Blacklisted genes}
\format{
A character vector of Entrez Gene IDs
}
\source{
\url{https://software.broadinstitute.org/cancer/cga/mutsig}
}
\usage{
mutSig
}
\description{
List of genes to not include in the DIGGIT mutation inference because they 
have been found to be mutated more often than expected by chance given 
background mutation processes.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rank.r
\name{stoufferIntegrate}
\alias{stoufferIntegrate}
\title{dispatch method for either CNV location corrected or SNV}
\usage{
stoufferIntegrate(interactions, cytoband.map = NULL)
}
\arguments{
\item{interactions}{List of MR - Genomic Event interactions, inferred by DIGGIT}

\item{cytoband.map}{Data.frame mapping Entrez.IDs to cytoband locations}
}
\value{
Z-scores for each MR
}
\description{
dispatch method for either CNV location corrected or SNV
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genomic.saturation.r
\name{getCoverage}
\alias{getCoverage}
\title{Get coverage of interactions}
\usage{
getCoverage(
  MomaObject,
  cMR.ranking,
  viper.samples,
  topN = 100,
  mutation.filter = NULL,
  verbose = FALSE
)
}
\arguments{
\item{MomaObject}{A numeric vector with cluster membership, names are samples}

\item{cMR.ranking}{A vector entrez IDs, in order}

\item{viper.samples}{Calculate the genomic coverage only for these sample}

\item{topN}{Compute coverage for only the top -N- Master Regulators}

\item{mutation.filter}{Retain only mutation events in this (positive) list}
}
\value{
A list of lists, indexed by sample name, with coverage statistics
for each sample
}
\description{
Get coverage of interactions
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.saturation.plots.r
\name{plotEvents}
\alias{plotEvents}
\title{Plot barchart of genomic events}
\usage{
plotEvents(
  summary.vec,
  highlight.genes = NULL,
  genomeBand_2_gene = NULL,
  samples.total,
  max.muts = 10,
  max.cnv = 5
)
}
\arguments{
\item{summary.vec}{: named vector of the counts, named 'Event name':'Type'
where type is 'mut', 'amp', 'del', 'fus'. Mutations are in Entrez ID
Amp/Deletion CNV events are in genomic band location}

\item{highlight.genes}{: well known genes to highlight in the analysis in}

\item{genomeBand_2_gene}{: mapping of genomic location IDs to gene name: 
vector of HUGO gene ids, named by genomic loci}

\item{samples.total}{: number of samples in the subtype, used to calculate percentages}

\item{max.muts}{: maximum number of mutations to get per sample, default is 10}

\item{max.cnv}{: maximum number of cnvs to per sample, default is 5}
}
\value{
plot object
}
\description{
Plot barchart of genomic events
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diggit.r
\name{associateEvents}
\alias{associateEvents}
\title{Use 'aREA' to calculate the enrichment between each genomic event - 
VIPER inferred protein pair.}
\usage{
associateEvents(
  vipermat,
  events.mat,
  min.events = NA,
  whitelist = NA,
  event.type = c("Amplifications", "Deletions", "Mutations", "Fusions", NA),
  verbose
)
}
\arguments{
\item{vipermat}{Pre-computed VIPER scores with samples as columns and proteins
as rows}

\item{events.mat}{Binary 0/1 events matrix with samples as columns and genes 
or events as rows}

\item{min.events}{Only compute enrichment if the number of samples with these
events is GTE to this}

\item{whitelist}{Only compute associations for events in this list}

\item{event.type}{Name of the event type being analyzed}

\item{verbose}{whether to print extra progress statements}
}
\value{
A matrix of aREA scores, dimensions are nrow(events.mat) x nrow(vipermat)
}
\description{
Requires pre-computed VIPER scores and a binary events matrix. Will use only 
samples in both event and VIPER matrices.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/moma.r
\name{sampleNameFilter}
\alias{sampleNameFilter}
\title{Retain TCGA sample ids without the final letter designation ('A/B/C')}
\usage{
sampleNameFilter(input, desired.len = 15)
}
\arguments{
\item{input}{Matrix of expression or protein activity scores. Columns are 
sample names, rows are genes. Input can also just be an input vector of 
sample names.}

\item{desired.len}{length to reduce strings to. Default is 15 because of 
TCGA naming conventions}
}
\value{
An identical matrix with new (shorter) column names, 
or a vector with the shortened names.
}
\description{
Retain TCGA sample ids without the final letter designation ('A/B/C')
}
\examples{
sample.names <- c("TCGA-14-1825-01A", "TCGA-76-4931-01B", "TCGA-06-5418-01A")
sampleNameFilter(sample.names)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dictionary.functions.R
\name{mapHugo}
\alias{mapHugo}
\title{Convert from hugo gene names to entrez ids}
\usage{
mapHugo(hugo.ids)
}
\arguments{
\item{hugo.ids}{: vector of hugo gene names, requires hugo2entrez to be loaded}
}
\value{
: vector of entrez ids
}
\description{
Convert from hugo gene names to entrez ids
}
\examples{
mapHugo(c("A1CF","PTEN"))
}
\seealso{
\code{\link[MOMA]{mapEntrez}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rank.r
\name{conditionalP}
\alias{conditionalP}
\title{Get the conditional p-value of a gene}
\usage{
conditionalP(gene.name, condition.on, x)
}
\arguments{
\item{gene.name}{Character}

\item{condition.on}{named Vector of scores for the distribution we are conditioning ON}

\item{x}{named Vector of scores for the dependent distribution}
}
\value{
a numeric p-value between 0 and 1
}
\description{
Get the conditional p-value of a gene
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dictionary.functions.R
\name{mapEntrez}
\alias{mapEntrez}
\title{Convert from entrez ids to hugo gene names}
\usage{
mapEntrez(entrez.ids)
}
\arguments{
\item{entrez.ids}{: vector of entrez ids requires hugo2entrez to be loaded}
}
\value{
: vector of hugo gene names
}
\description{
Convert from entrez ids to hugo gene names
}
\examples{
mapEntrez(c("29974", "5728"))
}
\seealso{
\code{\link[MOMA]{mapHugo}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.saturation.plots.r
\name{mergeData}
\alias{mergeData}
\title{Helper function for mergeDataBySubtype}
\usage{
mergeData(coverage.range, topN)
}
\arguments{
\item{coverage.range}{: genomic saturation for a particular subtype}

\item{topN}{: max number of top regulators to search through}
}
\value{
dataframe with coverage data for genomic events
}
\description{
Helper function for mergeDataBySubtype
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster.r
\name{clusterRange}
\alias{clusterRange}
\title{Cluster Range}
\usage{
clusterRange(
  dis,
  range = c(2, 100),
  step = 1,
  cores = 1,
  method = c("pam", "kmeans"),
  data = NULL
)
}
\arguments{
\item{dis}{Distance object}

\item{range}{vector with start and end 'k'}

\item{step}{Integer indicating the incremental number of clusters to add in each iteration}

\item{cores}{Maximum number of CPU cores to use}

\item{method}{Either 'pam' k-mediods or kmeans. Must supply the original data matrix if using kmeans}

\item{data}{Original data matrix}
}
\value{
list of cluster reliability scores by 'k', 'clustering' (the vector solution) and 'reliability' 
as well as 'medoids' labels
}
\description{
This function generate an cluster structure with 'k' groups and computes the cluster reliability score
where 'k' is a range of values
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rank.r
\name{stoufferIntegrateDiggit}
\alias{stoufferIntegrateDiggit}
\title{Use Stouffer's method to combine z-scores of DIGGIT interactions for each cMR protein.}
\usage{
stoufferIntegrateDiggit(interactions, from.p = FALSE, pos.nes.only = TRUE)
}
\arguments{
\item{interactions}{A list indexed by TF, includes z-scores or p-values for each interacting event}

\item{from.p}{Integrate p-values or z-scores (default z-scores; from.p = FALSE)}

\item{pos.nes.only}{Use only positive NES scores to rank proteins (default TRUE)}
}
\value{
A list indexed by TF, a stouffer integrated z-score
}
\description{
This function combines only positively associated DIGGIT scores by default to create a culmulative DIGGIT score for each cMR.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genomic.saturation.r
\name{sampleOverlap}
\alias{sampleOverlap}
\title{The core function to compute which sample-specific alterations overlap with 
genomic events that are explained 
via DIGGIT.}
\usage{
sampleOverlap(
  MomaObject,
  viper.samples,
  selected.tfs,
  interaction.map,
  cnv.threshold = 0.5,
  mutation.filter = NULL,
  idx.range = NULL,
  verbose = FALSE
)
}
\arguments{
\item{MomaObject}{Object reference of momaRunner class}

\item{viper.samples}{Sample vector to restrict sample-specific analysis to}

\item{selected.tfs}{Transcription factors being analyzed}

\item{interaction.map}{List object of events 'covered' by the supplied 
interactions of type mut/amp/del/fus}

\item{cnv.threshold}{Numeric absolute value to threshold SNP6 and/or GISTIC 
or other CNV scores. Above that absolute value is considered a positive event.}

\item{mutation.filter}{A vector of whitelisted mutation events, in entrez gene IDs}

\item{idx.range}{Number of tfs to check for genomic saturation calculation, 
default is 1253}

\item{verbose}{Output status during the run (default=FALSE)}
}
\value{
A list of lists, indexed by sample name, with coverage 
statistics/data for each sample
}
\description{
The core function to compute which sample-specific alterations overlap with 
genomic events that are explained 
via DIGGIT.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example.gbm.data.r
\docType{data}
\name{gbm.pathways}
\alias{gbm.pathways}
\title{Glioblastoma (GBM) Pathways}
\format{
A list of lists named "cindy" and "preppi" respectively
\describe{
\item{cindy}{list of regulators, each with a set of modulators and p values
representing their CINDY inferred association}
\item{preppi}{list of regulators, each with a set of potential binding
partners and PREPPi inferred p values for probability of binding}
}
}
\usage{
gbm.pathways
}
\description{
Object containing information about the biological pathways that will be used
in the analysis
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diggit.r
\name{reaNULL}
\alias{reaNULL}
\title{This function generates the NULL model function, which computes the 
normalized enrichment score and associated p-value}
\usage{
reaNULL(regulon, minsize = 1, maxsize = Inf)
}
\arguments{
\item{regulon}{A list with genomic features as its names and samples as its 
entries}

\item{minsize}{Minimum number of event (or size of regulon)}

\item{maxsize}{Maximum number of event (or size of regulon)}
}
\value{
A list of functions to compute NES and p-value
}
\description{
This function generates the NULL model function, which computes the 
normalized enrichment score and associated p-value
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rank.r
\name{conditionalModel}
\alias{conditionalModel}
\title{Implements the conditional Bayes model to combine VIPER scores with diggit 
and pathway scores}
\usage{
conditionalModel(viper.scores, diggit.scores, pathway.scores)
}
\arguments{
\item{viper.scores}{numeric Vector}

\item{diggit.scores}{List indexed by type char, with numeric score vectors in [0,R+] for each}

\item{pathway.scores}{List , double indexed by each pathway dataset, 
then with type char. Each points to a numeric score vectors in [0,R+] for each}
}
\value{
a named vector of empirical p-values for each protein/candidate Master Regulator
}
\description{
Implements the conditional Bayes model to combine VIPER scores with diggit 
and pathway scores
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.interactions.r
\name{getDiggitEmpiricalQvalues}
\alias{getDiggitEmpiricalQvalues}
\title{Compute the empirical q-values of each genomic-event/VIPER gene pair}
\usage{
getDiggitEmpiricalQvalues(vipermat, nes, null.TFs, alternative = "both")
}
\arguments{
\item{vipermat}{viper inferences matrix, samples are columns, 
rows are TF entrez gene IDs}

\item{nes}{scores for each mutation (rows) against each TF (columns)}

\item{null.TFs}{low-importance TFs used to calculate null distributions}

\item{alternative}{Alternative defaults to 'both' : significant p-values can 
come from both sides of the null distribution}
}
\value{
A named list of qvalues for each TF/cMR protein. Each entry contains 
a vector of q-values for all associated events; names are gene ids
}
\description{
Use against the background distribution of associations with a given set of 
'null' VIPER genes (i.e. low activity TFs)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genomic.saturation.r
\name{mergeGenomicSaturation}
\alias{mergeGenomicSaturation}
\title{mergeGenomicSaturation Create data frame from coverage data, including
 number of total events 'covered' and unique events}
\usage{
mergeGenomicSaturation(coverage.range, topN)
}
\arguments{
\item{coverage.range}{List indexed by sample, then sub-indexed by # of master
regulators, then by event type (mut/amp/del/fus). Holds all events by sample}

\item{topN}{Maximum number of master regulators to compute coverage}
}
\value{
A data frame with summary statistics for genomic saturation at each k
}
\description{
mergeGenomicSaturation Create data frame from coverage data, including
 number of total events 'covered' and unique events
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.interactions.r
\name{viperGetSigTFS}
\alias{viperGetSigTFS}
\title{Calculate p-values from pseudo zscores / VIPER aREA scores, threshold}
\usage{
viperGetSigTFS(zscores, fdr.thresh = 0.05)
}
\arguments{
\item{zscores}{Vector of normally distributed z-scores representing protein 
activities.}

\item{fdr.thresh}{Threshold for false discovery rate, default is 0.05}
}
\value{
Get the names of proteins with significant z-scores, after 
multi-hypothesis correction
}
\description{
Calculate p-values from pseudo zscores / VIPER aREA scores, threshold
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.interactions.r
\name{getEmpiricalQvals}
\alias{getEmpiricalQvals}
\title{Get empirical qvals}
\usage{
getEmpiricalQvals(test.statistics, null.statistics, alternative = "both")
}
\arguments{
\item{test.statistics}{P-values generated from the test comparisons}

\item{null.statistics}{P-values generated under the null (permutation) model}

\item{alternative}{Optional : 1 or 2 tails used to generate the p-value}
}
\value{
A list with both the qvalues and empirical p-values from the supplied
test and null stats
}
\description{
Get empirical qvals
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.interactions.r
\name{viperGetTFScores}
\alias{viperGetTFScores}
\title{Function to normalize TF scores}
\usage{
viperGetTFScores(vipermat, fdr.thresh = 0.05)
}
\arguments{
\item{vipermat}{- matrix of VIPER scores with columns as samples, 
rows as protein names}

\item{fdr.thresh}{- BH-FDR threshold (default 0.05 FDR rate)}
}
\value{
A vector of normalized z-scores, named by TF id
}
\description{
Function to normalize TF scores
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/moma.r
\name{MomaConstructor}
\alias{MomaConstructor}
\title{MOMA Constructor Function}
\usage{
MomaConstructor(
  x,
  pathways,
  gene.blacklist = NA_character_,
  output.folder = NA_character_,
  gene.loc.mapping = gene.map,
  viperAssay = "viper",
  mutMat = "mut",
  cnvMat = "cnv",
  fusionMat = "fusion"
)
}
\arguments{
\item{x}{A MultiAssayExerperiment object or list object with the following assays:
(note: by default assays must have these exact names. Otherwise they can be changed
using the viperAssay, mutMat, cnvMat and fusionMat parameters.)
\describe{
\item{viper}{VIPER protein activity matrix with samples as columns 
and rows as protein IDs}
\item{mut}{An indicator matrix (0/1) of mutation events with samples as 
columns and genes as rows}
\item{cnv}{A matrix of CNV scores (typically SNP6 array scores from TCGA) 
with samples as columns and genes as rows}
\item{fusion}{An indicator matrix (0/1) of fusion events with samples as 
columns and genes as rows} }}

\item{pathways}{A named list of lists. Each named list represents 
interactions between proteins (keys) and their associated partners}

\item{gene.blacklist}{A vector of genes to exclude from the analysis}

\item{output.folder}{Location to store output and intermediate results}

\item{gene.loc.mapping}{A data.frame of band locations and Entrez IDs}

\item{viperAssay}{name associated with the viper assay in the assay object}

\item{mutMat}{name associated with the mutation matrix in the assay object}

\item{cnvMat}{name associated with the cnv matrix in the assay object}

\item{fusionMat}{name associated with the fusion matrix in the assay object}
}
\value{
an instance of class Moma
}
\description{
Create MOMA Object from either a MultiAssayExperiment object or a list of
assays.
See vignette for more information on how to set up and run the MOMA object
}
\examples{
momaObj <- MomaConstructor(example.gbm.mae, gbm.pathways)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/moma.r
\name{checkPathways}
\alias{checkPathways}
\title{Check Pathways}
\usage{
checkPathways(pathways, x, type)
}
\arguments{
\item{pathways}{A named list of lists. Each named list represents 
interactions between proteins (keys) and their associated partners}

\item{x}{the MAE or Assaylist}

\item{type}{whether x is MAE or Assaylist}
}
\value{
nothing
}
\description{
Check Pathways
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rank.r
\name{pathwayDiggitIntersect}
\alias{pathwayDiggitIntersect}
\title{Combine DIGGIT inferences with pathway knowledge}
\usage{
pathwayDiggitIntersect(diggit.int, pathway, pos.nes.only = TRUE, cores = 1)
}
\arguments{
\item{diggit.int}{List of interactions between MRs - Genomic events, inferred
by DIGGIT}

\item{pathway}{- a list indexed by TF/MR entrez ID, contains the named vector
of p-values for interactions}

\item{pos.nes.only}{Only use positive associations between MR activity and 
presence of events (default = True)}

\item{cores}{Number of cores to use if parallel is selected}
}
\value{
numeric vector, zscores for each TF/MR
}
\description{
Combine DIGGIT inferences with pathway knowledge
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.r
\docType{data}
\name{gene.map}
\alias{gene.map}
\title{Gene Location Mapping}
\format{
A Data frame with 4 columns
\describe{
\item{Gene.Symbol}{Approved Symbol gene name}
\item{Entrez.IDs}{NCBI Gene ID}
\item{Cytoband}{Chromosome location}
\item{Ensembl}{Ensembl gene ID}
}
 @source \url{https://www.genenames.org/download/custom/}
}
\usage{
gene.map
}
\description{
Table used for converting between different forms of gene information.
Downloaded from HGNC's custom download portal using the "Approved Symbol", 
"NCBI Gene ID", "Chromosome" and "Ensembl Gene ID" curated data options 
and only those with "Approved" status.
Updated December 2019.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diggit.r
\name{areaEnrich}
\alias{areaEnrich}
\title{aREA.enrich Compute aREA enrichment between all pairwise combinations of 
VIPER proteins and gene-level events}
\usage{
areaEnrich(events.mat, vipermat, event.type, verbose)
}
\arguments{
\item{events.mat}{A Binary 0/1 matrix with columns as samples, and rows as 
proteins}

\item{vipermat}{A VIPER network of inferred activity scores with columns as 
samples, and rows as proteins}

\item{event.type}{Name of the event type for printing purposes}

\item{verbose}{whether to print extra progress statements}
}
\value{
A matrix of enrichment scores with rows as event/gene names and 
columns as VIPER protein names
}
\description{
aREA.enrich Compute aREA enrichment between all pairwise combinations of 
VIPER proteins and gene-level events
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rank.r
\name{mapScoresCnvBand}
\alias{mapScoresCnvBand}
\title{Map scores to cytoband location}
\usage{
mapScoresCnvBand(
  mapping,
  diggit.interactions,
  from.p = FALSE,
  pos.nes.only = TRUE
)
}
\arguments{
\item{mapping}{a named vector of genomic locations/cytoband IDs. 
names are the gene names for each--i.e. a many to one mapping from HUGO or entrez IDs to
cytoband location}

\item{diggit.interactions}{list indexed by MR/TF name in Entrez Space}

\item{from.p}{DIGGIT interactions are in p-value format instead of z-score (default=FALSE)}

\item{pos.nes.only}{Only consider positive associations with NES scores (default=TRUE)
each points to a named vector of NES / z-scores associated with entrez IDs for each interacting event.}
}
\value{
A list of input scores, now named by cytoband location
}
\description{
Map scores to cytoband location
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.saturation.plots.r
\name{oncoprintPlot}
\alias{oncoprintPlot}
\title{Function to plot genomic events in the style of oncoPrint/cBioPortal}
\usage{
oncoprintPlot(
  summary.vec,
  snpmat.thisClus,
  amps.thisClus,
  dels.thisClus,
  fusions.thisClus,
  important.genes,
  band2gene,
  max.events,
  k
)
}
\arguments{
\item{summary.vec}{: named vector of the counts, named 'Event name':'Type'
where type is 'mut', 'amp', 'del', 'fus'. Mutations are in Entrez ID
Amp/Deletion CNV events are in genomic band location}

\item{snpmat.thisClus}{: SNP matrix subset to samples in current cluster}

\item{amps.thisClus}{: CNV matrix subset to samples in current cluster (just amplifications)}

\item{dels.thisClus}{: CNV matrix subset to samples in current cluster (just deletions)}

\item{fusions.thisClus}{: Fusion matrix subset to samples in current cluster}

\item{important.genes}{: well known genes to highlight in the analysis}

\item{band2gene}{: mapping of genomic location IDs to gene name: vector of 
HUGO gene ids, named by genomic location}

\item{max.events}{: maximum number of events to plot for the oncoplots}

\item{k}{: current cluster number}
}
\value{
oncoprint event plot
}
\description{
Function to plot genomic events in the style of oncoPrint/cBioPortal
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/diggit.r
\name{rea}
\alias{rea}
\title{This function calculates an Enrichment Score of Association based on how the
features rank on the samples sorted by a specific gene}
\usage{
rea(eset, regulon, minsize = 1, maxsize = Inf, event.type = NA, verbose)
}
\arguments{
\item{eset}{Numerical matrix}

\item{regulon}{A list with genomic features as its names and samples as its 
entries, indicating presence of event}

\item{minsize}{The minimum number of events to use when calculating enrichment}

\item{maxsize}{The maximum number of events to use when calculating enrichment}

\item{event.type}{Type of event being analyzed}

\item{verbose}{whether to print extra progress statements}
}
\value{
A list containing two elements:
\describe{
\item{groups}{Regulon-specific NULL model containing the enrichment scores}
\item{ss}{Direction of the regulon-specific NULL model}
}
}
\description{
This function calculates an Enrichment Score of Association based on how the
features rank on the samples sorted by a specific gene
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.saturation.plots.r
\name{makeCoverageDf}
\alias{makeCoverageDf}
\title{Helper function for making the coverage dataframe}
\usage{
makeCoverageDf(coverage.list, cutoff)
}
\arguments{
\item{coverage.list}{: List indexed by sample name, 
contains mut/fus/amp/del interactions}

\item{cutoff}{: number of regulators to include}
}
\value{
dataframe with each sample and which events are 
captured by the checkpoint mrs
}
\description{
Helper function for making the coverage dataframe
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.saturation.plots.r
\name{getDataFrame}
\alias{getDataFrame}
\title{Helper function to get data frame for bar plot plot.events function}
\usage{
getDataFrame(
  data,
  highlight.genes,
  genomeBand_2_gene,
  max.muts = 10,
  max.cnv = 5
)
}
\arguments{
\item{data}{data.frame with $type, $id, $Freq per event}

\item{highlight.genes}{genes to look for in mutations/cnv lists (if looking
for specific genes because of prior knowledge)}

\item{genomeBand_2_gene}{mapping of genomic location IDs to gene name: 
vector of HUGO gene ids, named by genomic loci}

\item{max.muts}{maximum number of mutations to get per sample, default is 10}

\item{max.cnv}{maximum number of cnvs to per sample, default is 5}
}
\value{
ordered data frame with each genomic event and it's frequency
}
\description{
Helper function to get data frame for bar plot plot.events function
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genomic.saturation.r
\name{subsetListInteractions}
\alias{subsetListInteractions}
\title{Helper function: subset a list to the set of keys supplied return the 
names of interactions with positive values, in a list structure}
\usage{
subsetListInteractions(int.l, keys)
}
\arguments{
\item{int.l}{List of interactions, at each index this is a numeric named vector}

\item{keys}{Keys used to reduce interactions}
}
\value{
Returns a filtered list of interactions in the same format as the input
}
\description{
Helper function: subset a list to the set of keys supplied return the 
names of interactions with positive values, in a list structure
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rank.r
\name{empiricalP}
\alias{empiricalP}
\title{Get the empirical p-value from a distribution (vector)}
\usage{
empiricalP(gene.name, x)
}
\arguments{
\item{gene.name}{Character}

\item{x}{named Vector of scores for the distribution}
}
\value{
a numeric p-value between 0 and 1
}
\description{
Get the empirical p-value from a distribution (vector)
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.interactions.r
\name{sigInteractorsDIGGIT}
\alias{sigInteractorsDIGGIT}
\title{Filter interactions from NES (DIGGIT) scores and corresponding 
background-corrected scores.}
\usage{
sigInteractorsDIGGIT(
  corrected.scores,
  nes.scores,
  cindy,
  p.thresh = 0.05,
  cindy.only = TRUE
)
}
\arguments{
\item{corrected.scores}{A list indexed by the genomic event/gene with 
corresponding pvals and qvals for each TF}

\item{nes.scores}{Matrix with tfs as columns, rows are genomic events}

\item{cindy}{CINDy algorithm output matrix}

\item{p.thresh}{P-value threshold (default=0.05)}

\item{cindy.only}{Consider only CINDy validated interactions (default=TRUE)}
}
\value{
a list (indexed by VIPER protein) of significant genomic interactions 
and associated pvals over the background (null TF) model, and NES scores
}
\description{
Use this version in the Bayes model to rank TFs
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster.r
\name{integrateFunction}
\alias{integrateFunction}
\title{Numerical integration of functions}
\usage{
integrateFunction(f, xmin, xmax, steps = 100, ...)
}
\arguments{
\item{f}{Function of 1 variable (first argument)}

\item{xmin}{Number indicating the min x value}

\item{xmax}{Number indicating the max x value}

\item{steps}{Integer indicating the number of steps to evaluate}

\item{...}{Additional arguments for \code{f}}
}
\value{
Number
}
\description{
Integrates numerically a function over a range using the trapezoid method
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genomic.saturation.r
\name{mergeLists}
\alias{mergeLists}
\title{Helper function}
\usage{
mergeLists(l1, l2)
}
\arguments{
\item{l1}{list 1}

\item{l2}{list 2}
}
\value{
single merged list
}
\description{
Helper function
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster.r
\name{integrateTZ}
\alias{integrateTZ}
\title{Integration with trapezoid method}
\usage{
integrateTZ(x, y)
}
\arguments{
\item{x}{Numeric vector of x values}

\item{y}{Numeric vector of y values}
}
\value{
Number
}
\description{
This function integrate over a numerical range using the trapezoid method
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.saturation.plots.r
\name{mergeDataBySubtype}
\alias{mergeDataBySubtype}
\title{Create data frame from coverage data, including number of total events 
'covered' and unique events}
\usage{
mergeDataBySubtype(genomic.saturation, sample.clustering, topN = 100)
}
\arguments{
\item{genomic.saturation}{: data from genomic saturation function}

\item{sample.clustering}{: clustering vector with sample names and 
cluster designations}

\item{topN}{: number of regulators to look through. default is 100}
}
\value{
dataframe with coverage data for genomic events
}
\description{
Create data frame from coverage data, including number of total events 
'covered' and unique events
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example.gbm.data.r
\docType{data}
\name{example.gbm.mae}
\alias{example.gbm.mae}
\title{Glioblastoma (GBM) Example Dataset}
\format{
An MultiAssayExperiment object with 4 different sets of GBM assays
\describe{
\item{viper}{matrix of viper scores with samples in columns and regulators
 across the rows}
\item{mut}{matrix of samples and genes with potential mutations.
0 for no mutation, 1 for presence of some non-silent mutation}
\item{cnv}{matrix of samples and genes with copy number variant scores}
}
}
\usage{
example.gbm.mae
}
\description{
MultiAssayExperiment Object containing all the genomic assays needed to run
the example code for MOMA
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster.r
\name{sREA}
\alias{sREA}
\title{Simple one-tail rank based enrichment analysis sREA
(for cluster analysis)}
\usage{
sREA(signatures, groups)
}
\arguments{
\item{signatures}{Numeric matrix of signatures}

\item{groups}{List containing the groups as vectors of sample names}
}
\value{
Matrix of Normalized Enrichment Zcores
}
\description{
This function performs simple 1-tail rank based enrichment analysis
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.saturation.plots.r
\name{genomicPlotSmall}
\alias{genomicPlotSmall}
\title{Make small genomic plot}
\usage{
genomicPlotSmall(input.df, fraction = 0.85, tissue.cluster = NULL)
}
\arguments{
\item{input.df}{: tissue.coverage.df with mean, k, fraction and unique events.}

\item{fraction}{: what fraction coverage to use for genomic curve threshold}

\item{tissue.cluster}{: which cluster subsample to look at}
}
\value{
output .png
}
\description{
Make small genomic plot
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster.r
\name{clusterReliability}
\alias{clusterReliability}
\title{Cluster membership reliability estimated by enrichment analysis}
\usage{
clusterReliability(
  cluster,
  similarity,
  xlim = NULL,
  method = c("element", "cluster", "global")
)
}
\arguments{
\item{cluster}{Vector of cluster memberships or list of cluster memberships}

\item{similarity}{Similarity matrix}

\item{xlim}{Optional vector of 2 components indicating the limits for computing AUC}

\item{method}{Character string indicating the mthod to compute reliability, 
either by element, by cluster or global}
}
\value{
Reliability score for each element
}
\description{
This function estimates the cluster membership reliability using aREA
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/moma.r
\name{checkList}
\alias{checkList}
\title{Check List of Assays}
\usage{
checkList(assaylist)
}
\arguments{
\item{assaylist}{list of assays (viper, cnv, mut and fusion)}
}
\value{
updated/filter assaylist obj
}
\description{
Check List of Assays
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/moma.r
\name{checkMAE}
\alias{checkMAE}
\title{Check MultiAssayExperiment}
\usage{
checkMAE(mae)
}
\arguments{
\item{mae}{MultiAssayExperiment object}
}
\value{
updated/filtered MAE
}
\description{
Check MultiAssayExperiment
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/genomic.saturation.r
\name{fitCurvePercent}
\alias{fitCurvePercent}
\title{Fit based on fractional overall coverage of genomic events}
\usage{
fitCurvePercent(sweep, frac = 0.85)
}
\arguments{
\item{sweep}{Numeric vector of genomic coverage values, named by -k- threshold}

\item{frac}{Fraction of coverage to use as a threshold (default .85 = 85 percent)}
}
\value{
The -k- integer where coverage is acheived
}
\description{
Fit based on fractional overall coverage of genomic events
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/moma.r
\name{checkGeneMap}
\alias{checkGeneMap}
\title{Check Gene Map}
\usage{
checkGeneMap(gene.loc.mapping)
}
\arguments{
\item{gene.loc.mapping}{dataframe with gene names, entrez ids and cytoband locations}
}
\value{
nothing
}
\description{
Check Gene Map
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.saturation.plots.r
\name{getSubtypeEventTables}
\alias{getSubtypeEventTables}
\title{Helper function to get subtype specific events}
\usage{
getSubtypeEventTables(saturation.data, sample.clustering, checkpoints)
}
\arguments{
\item{saturation.data}{: genomic saturation object from MOMA. List indexed by 
cluster then sample then regulator with the number of events associated with 
each additional regulator}

\item{sample.clustering}{: clustering vector with sample names and 
cluster designations}

\item{checkpoints}{: from momaObj}
}
\value{
a table that has counts of how many times a particular event 
happens in a cluster
}
\description{
Helper function to get subtype specific events
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make.saturation.plots.r
\name{makeSaturationPlots}
\alias{makeSaturationPlots}
\title{Main function to generate the summary plots of the analysis}
\usage{
makeSaturationPlots(
  momaObj,
  clustering.solution = NULL,
  important.genes = NULL,
  fCNV = NULL,
  max.events = 30
)
}
\arguments{
\item{momaObj}{: momaObj that has already run the saturationCalculation function}

\item{clustering.solution}{: clustering vector with sample names and cluster designations}

\item{important.genes}{: vector of gene names to prioritize when plotting. 
Can be general genes of interest, oncogenes, tumor supressors etc}

\item{fCNV}{: vector of confirmed functional CNVs if calculated. Will filter for only those CNVs}

\item{max.events}{: maximum number of events to plot for the oncoplots}
}
\value{
object with both types of summary plot for each subtype
}
\description{
Main function to generate the summary plots of the analysis
}
\examples{

\dontrun{
makeSaturationPlots(momaObj, max.events = 20)
}
}
